/////////////////////////////////////////////////////////////////////////////////////////// CalculVoiePont()F //////////////////////////////////////////////////////////////////////////////
void CalculVoiePont(int _c_voie_pont, int _l_voie_pont, int _z, int _longueur_voie, int _hauteur_voie) {

    max_ordre     = 0;
    float radius  = 0;
    float alpha  = 0F;
    voie_pont_droite = false;
    boolean found = false;
    
    pave = tco.paves[_c_voie_pont][_l_voie_pont];
    if (pave != null && pave.ordre != 0) {
        alpha = pave.ordre;
        found = true;
    } else {
        for (int i = 0; i < 160; i = i+2) {                                                                                  //  on cherche si le pavé de voie de pont tournant est dans les pavés reserves
            if ((Pont[i] == _c_voie_pont) && (Pont[i+1] == _l_voie_pont) && (Pont[i] != 0)) {
                found  = true;
                alpha = i/2F;
                break;
            }
        }
    }
    pave      = pavePont;                                                           //  on a besoin d'aller chercher dans le pont tournant les infos ...
    if (pave != null) {
        max_ordre = pave.ordre;                                                                                         //  nombre maximal de voies
        radius    = (1F+pave.elongation)/2F;                                                                                         //  taille du pont
    }
    //---------------------------------------------- calcul de la longueur de la voie en rayon simple ---------------------------------------------
    float track_length = 0;
    track_length = (max_ordre/8F-0.5F)*MAILLE;                                                                               //  c'est la longueur par defaut de la voie en rayon simple
    alpha  = alpha*2*PI/max_ordre;                                                                                            //  alpha est l'angle entre deux voie du pont
    alpha  = alpha%(2*PI);                                                                                                    //  alpha modulo 2*PI
    if (_longueur_voie == 0 && _hauteur_voie == 0) { //------------------------------------------------------------------------------------------------------------------ the case of the the simplex mode
        if (found) {                                                                                                                          //  calculus for position on the turn table
            X4_x = (c0_pont+radius*cos(alpha)-_c_voie_pont)*MAILLE;                                                                  //  coordinates of the center of the new system
            X4_y = (l0_pont-radius*sin(alpha)-_l_voie_pont)*MAILLE;            
            X3_x = X4_x+(track_length-radius*MAILLE+_z-1F)*cos(alpha);
            X3_y = X4_y-(track_length-radius*MAILLE+_z-1F)*sin(alpha);
            P1_x = X4_x+(track_length+RAIL-radius*MAILLE+_z-1F)*cos(alpha);
            P1_y = X4_y-(track_length+RAIL-radius*MAILLE+_z-1F)*sin(alpha);
            if (sqrt((_c_voie_pont*MAILLE+X3_x-c0_pont*MAILLE)*(_c_voie_pont*MAILLE+X3_x-c0_pont*MAILLE)
                    +(_l_voie_pont*MAILLE+X3_y-l0_pont*MAILLE)*(_l_voie_pont*MAILLE+X3_y-l0_pont*MAILLE)) < radius*MAILLE) {
                X3_x = X4_x;
                X3_y = X4_y;
            }
        } else {                                                                                                                              //----------  calculus for position out of the pont
            X3_x = MAILLE/3F;
            X3_y = MAILLE/3F;
            X4_x = X3_x+2F*MAILLE/3F/sqrt(2);
            X4_y = X3_y+2F*MAILLE/3F/sqrt(2);
            P1_x = X3_x-RAIL/sqrt(2);
            P1_y = X3_y-RAIL/sqrt(2);
        } //<>//
    } else { //-------------------------------------------------------------------------------------------------------------------------------  the case of the complex mode
        pave = tco.paves[_c_voie_pont][_l_voie_pont];
        if (pave != null) {            
            if (tco.paves[_c_voie_pont][_l_voie_pont].ordre == 8F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 2F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 4F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 6F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 1F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 3F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 5F*max_ordre/8F
             || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 7F*max_ordre/8F) {
                voie_pont_droite = true;
                X4_x = (c0_pont+radius*cos(alpha)-_c_voie_pont)*MAILLE;                                               //  coordinates of the center of the new system
                X4_y = (l0_pont-radius*sin(alpha)-_l_voie_pont)*MAILLE;                
                float straight_length = max_ordre/8F+0.5F;
                if (tco.paves[_c_voie_pont][_l_voie_pont].ordre == 1F*max_ordre/8F
                 || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 3F*max_ordre/8F
                 || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 5F*max_ordre/8F
                 || tco.paves[_c_voie_pont][_l_voie_pont].ordre == 7F*max_ordre/8F) {
                     straight_length = straight_length*sqrt(2);
                 }
                X3_x = X4_x+(straight_length*MAILLE-radius*MAILLE+_z-1F)*cos(alpha);
                X3_y = X4_y-(straight_length*MAILLE-radius*MAILLE+_z-1F)*sin(alpha);
            } else {
                float b    = 0F;
                int   sign = 0;
                switch (pave.orientation) {                                                                                               
                    case 5:
                        sign = 1;
                        voie_pont_1(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 6:
                        sign = -1;
                        voie_pont_1(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 1:
                        sign = 1;
                        voie_pont_2(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 2:
                        sign = -1;
                        voie_pont_2(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 7:
                        sign = -1;
                        voie_pont_3(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 3:
                        sign = 1;
                        voie_pont_3(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 8:
                        sign = 1;
                        voie_pont_4(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    case 4:
                        sign = -1;
                        voie_pont_4(alpha, sign, _c_voie_pont, _l_voie_pont, _hauteur_voie, _longueur_voie, b, _z, radius);
                        break;
                    default:
                }
            }
        }
    }
}

//-------------------------------------- void voie_pont_1 ------------------------------------
void voie_pont_1(float _alpha, int _sign, int _c_voie_pont, int _l_voie_pont, float _hauteur_voie, float _longueur_voie, float _b, int _z, float _radius) {
    _b    = ((l0_pont)+(tan(_alpha)*(c0_pont)))*MAILLE;
    Q1_y = (l0_pont+_hauteur_voie)*MAILLE;
    Q1_x = (_b-Q1_y)/tan(_alpha);

    X3_x = (c0_pont+_radius*cos(_alpha))*MAILLE-_c_voie_pont*MAILLE;
    X3_y = (l0_pont-_radius*sin(_alpha))*MAILLE-_l_voie_pont*MAILLE;
    X1_x = X3_x-RAIL/2F*sin(_alpha);
    X1_y = X3_y-RAIL/2F*cos(_alpha);
    X5_x = X3_x+RAIL/2F*sin(_alpha);
    X5_y = X3_y+RAIL/2F*cos(_alpha);
    
    X4_x = (c0_pont+_longueur_voie-0.5F)*MAILLE-_c_voie_pont*MAILLE;
    X4_y = Q1_y-_l_voie_pont*MAILLE;
    X2_x = X4_x;
    X2_y = X4_y-RAIL/2F;
    X6_x = X4_x;
    X6_y = X4_y+RAIL/2F;
    
    X_3_x = Q1_x-_c_voie_pont*MAILLE;
    X_3_y = Q1_y-_l_voie_pont*MAILLE;
    X_1_x = X_3_x-RAIL/2F*tan(_alpha/2F);
    X_1_y = X2_y;
    X_5_x = X_3_x+RAIL/2F*tan(_alpha/2F);
    X_5_y = X6_y;
    
    T4_x = Q1_x+_z*sin(_alpha/2F)-_c_voie_pont*MAILLE;
    T4_y = Q1_y-_l_voie_pont*MAILLE;
    T2_x = T4_x;
    T2_y = T4_y-RAIL/2F;
    T6_x = T4_x;
    T6_y = T4_y+RAIL/2F;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T2_x, T2_y);
    T1_x = X_m;
    T1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T4_x, T4_y);
    T3_x = X_m;
    T3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T6_x, T6_y);
    T5_x = X_m;
    T5_y = Y_m;
    
    center(T1_x, T1_y, T5_x, T5_y, T2_x, T2_y, T6_x, T6_y);
    C4_x = X_m;
    C4_y = Y_m;
    R4   = _z;
    R2   = R4+RAIL/2F;
    R6   = R4-RAIL/2F;
    
    P2_x = T2_x+_sign*magic(T1_x, T1_y, T2_x, T2_y, C4_x, C4_y)*R2;
    P2_y = T2_y;
    P4_x = T4_x+_sign*magic(T3_x, T3_y, T4_x, T4_y, C4_x, C4_y)*R4;
    P4_y = T4_y;
    P6_x = T6_x+_sign*magic(T5_x, T5_y, T6_x, T6_y, C4_x, C4_y)*R6;
    P6_y = T6_y;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P2_x, P2_y);
    P1_x = X_m;
    P1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P4_x, P4_y);
    P3_x = X_m;
    P3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P6_x, P6_y);
    P5_x = X_m;
    P5_y = Y_m;
}

//-------------------------------------- void voie_pont_2 ------------------------------------
void voie_pont_2(float _alpha, int _sign, int _c_voie_pont, int _l_voie_pont, float _hauteur_voie, float _longueur_voie, float _b, int _z, float _radius) {
    _b    = ((l0_pont)+(tan(_alpha)*(c0_pont)))*MAILLE;
    Q1_y = (l0_pont+_hauteur_voie)*MAILLE;
    Q1_x = (_b-Q1_y)/tan(_alpha);
    
    X3_x = (c0_pont+_radius*cos(_alpha))*MAILLE-_c_voie_pont*MAILLE;
    X3_y = (l0_pont-_radius*sin(_alpha))*MAILLE-_l_voie_pont*MAILLE;
    X1_x = X3_x+RAIL/2F*sin(_alpha);
    X1_y = X3_y+RAIL/2F*cos(_alpha);
    X5_x = X3_x-RAIL/2F*sin(_alpha);
    X5_y = X3_y-RAIL/2F*cos(_alpha);
    
    X4_x = (c0_pont+1F+_longueur_voie-0.5F)*MAILLE-_c_voie_pont*MAILLE;
    X4_y = Q1_y-_l_voie_pont*MAILLE;
    X2_x = X4_x;
    X2_y = X4_y-RAIL/2F;
    X6_x = X4_x;
    X6_y = X4_y+RAIL/2F;
    
    X_3_x = Q1_x-_c_voie_pont*MAILLE;
    X_3_y = Q1_y-_l_voie_pont*MAILLE;
    X_1_x = X_3_x+RAIL/2F/tan(_alpha/2F);
    X_1_y = X2_y;
    X_5_x = X_3_x-RAIL/2F/tan(_alpha/2F);
    X_5_y = X6_y;
    
    T4_x = Q1_x+_sign*_z*cos(_alpha/2F)-_c_voie_pont*MAILLE;
    T4_y = Q1_y-_l_voie_pont*MAILLE;
    T2_x = T4_x;
    T2_y = T4_y-RAIL/2F;
    T6_x = T4_x;
    T6_y = T4_y+RAIL/2F;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T2_x, T2_y);
    T1_x = X_m;
    T1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T4_x, T4_y);
    T3_x = X_m;
    T3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T6_x, T6_y);
    T5_x = X_m;
    T5_y = Y_m;
    
    center(T1_x, T1_y, T5_x, T5_y, T2_x, T2_y, T6_x, T6_y);
    C4_x = X_m;
    C4_y = Y_m;
    R4   = _z;
    R2   = R4+RAIL/2F;
    R6   = R4-RAIL/2F;
    
    P2_x = T2_x-_sign*magic(T1_x, T1_y, T2_x, T2_y, C4_x, C4_y)*R2;
    P2_y = T2_y;
    P4_x = T4_x-_sign*magic(T3_x, T3_y, T4_x, T4_y, C4_x, C4_y)*R4;
    P4_y = T4_y;
    P6_x = T6_x-_sign*magic(T5_x, T5_y, T6_x, T6_y, C4_x, C4_y)*R6;
    P6_y = T6_y;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P2_x, P2_y);
    P1_x = X_m;
    P1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P4_x, P4_y);
    P3_x = X_m;
    P3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P6_x, P6_y);
    P5_x = X_m;
    P5_y = Y_m;
}

//-------------------------------------- void voie_pont_3 ------------------------------------
void voie_pont_3(float _alpha, int _sign, int _c_voie_pont, int _l_voie_pont, float _hauteur_voie, float _longueur_voie, float _b, int _z, float _radius) {
    _b    = ((l0_pont)+((c0_pont)*tan(_alpha)))*MAILLE;
    Q1_x = (c0_pont+_longueur_voie)*MAILLE;
    Q1_y = -Q1_x*tan(_alpha)+_b;

    X3_x = (c0_pont+_radius*cos(_alpha))*MAILLE-_c_voie_pont*MAILLE;
    X3_y = (l0_pont-_radius*sin(_alpha))*MAILLE-_l_voie_pont*MAILLE;
    X1_x = X3_x-RAIL/2F*sin(_alpha);
    X1_y = X3_y-RAIL/2F*cos(_alpha);
    X5_x = X3_x+RAIL/2F*sin(_alpha);
    X5_y = X3_y+RAIL/2F*cos(_alpha);
    
    X4_x = Q1_x-_c_voie_pont*MAILLE;
    X4_y = (l0_pont+_hauteur_voie+0.5*_sign)*MAILLE-_l_voie_pont*MAILLE;
    X2_x = X4_x-_sign*RAIL/2F;
    X2_y = X4_y;
    X6_x = X4_x+_sign*RAIL/2F;
    X6_y = X4_y;
    
    X_3_x = Q1_x-_c_voie_pont*MAILLE;
    X_3_y = Q1_y-_l_voie_pont*MAILLE;
    X_1_x = X2_x;
    X_1_y = X_3_y+_sign*RAIL/2F*tan((_alpha-_sign*PI/2F)/2F);
    X_5_x = X6_x;
    X_5_y = X_3_y-_sign*RAIL/2F*tan((_alpha-_sign*PI/2F)/2F);

    T4_x = Q1_x-_c_voie_pont*MAILLE;
    T4_y = Q1_y-_z*sin((_alpha-_sign*PI/2F)/2F)-_l_voie_pont*MAILLE;
    T2_x = T4_x-_sign*RAIL/2F;
    T2_y = T4_y;
    T6_x = T4_x+_sign*RAIL/2F;
    T6_y = T4_y;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T2_x, T2_y);
    T1_x = X_m;
    T1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T4_x, T4_y);
    T3_x = X_m;
    T3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T6_x, T6_y);
    T5_x = X_m;
    T5_y = Y_m;

    center(T1_x, T1_y, T5_x, T5_y, T2_x, T2_y, T6_x, T6_y);
    C4_x = X_m;
    C4_y = Y_m;
    R4   = _z;
    R2   = R4+RAIL/2F;
    R6   = R4-RAIL/2F;
    
    P2_x = T2_x;
    P2_y = T2_y-_sign*magic(T1_x, T1_y, T2_x, T2_y, C4_x, C4_y)*R2;
    P4_x = T4_x;
    P4_y = T4_y-_sign*magic(T3_x, T3_y, T4_x, T4_y, C4_x, C4_y)*R4;
    P6_x = T6_x;
    P6_y = T6_y-_sign*magic(T5_x, T5_y, T6_x, T6_y, C4_x, C4_y)*R6;

    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P2_x, P2_y);
    P1_x = X_m;
    P1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P4_x, P4_y);
    P3_x = X_m;
    P3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P6_x, P6_y);
    P5_x = X_m;
    P5_y = Y_m;
}

//-------------------------------------- void voie_pont_4 ------------------------------------
void voie_pont_4(float _alpha, int _sign, int _c_voie_pont, int _l_voie_pont, float _hauteur_voie, float _longueur_voie, float _b, int _z, float _radius) {
    _b    = ((l0_pont)+((c0_pont)*tan(_alpha)))*MAILLE;
    Q1_x = (c0_pont+_longueur_voie)*MAILLE;
    Q1_y = -Q1_x*tan(_alpha)+_b;

    X3_x = (c0_pont+_radius*cos(_alpha))*MAILLE-_c_voie_pont*MAILLE;
    X3_y = (l0_pont-_radius*sin(_alpha))*MAILLE-_l_voie_pont*MAILLE;
    X1_x = X3_x-_sign*RAIL/2F*sin(_alpha);
    X1_y = X3_y-_sign*RAIL/2F*cos(_alpha);
    X5_x = X3_x+_sign*RAIL/2F*sin(_alpha);
    X5_y = X3_y+_sign*RAIL/2F*cos(_alpha);
    
    X4_x = Q1_x-_c_voie_pont*MAILLE;
    X4_y = (l0_pont+_hauteur_voie-0.5*_sign)*MAILLE-_l_voie_pont*MAILLE;
    X2_x = X4_x+RAIL/2F;
    X2_y = X4_y;
    X6_x = X4_x-RAIL/2F;
    X6_y = X4_y;
    
    X_3_x = Q1_x-_c_voie_pont*MAILLE;
    X_3_y = Q1_y-_l_voie_pont*MAILLE;
    X_1_x = X2_x;
    X_1_y = X_3_y-_sign*RAIL/2F*tan((PI/2F+_sign*_alpha)/2F);
    X_5_x = X6_x;
    X_5_y = X_3_y+_sign*RAIL/2F*tan((PI/2F+_sign*_alpha)/2F);

    T4_x = Q1_x-_c_voie_pont*MAILLE;
    T4_y = Q1_y+_sign*_z*sin((PI/2F+_sign*_alpha)/2F)-_l_voie_pont*MAILLE;
    T2_x = T4_x+RAIL/2F;
    T2_y = T4_y;
    T6_x = T4_x-RAIL/2F;
    T6_y = T4_y;
    
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T2_x, T2_y);
    T1_x = X_m;
    T1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T4_x, T4_y);
    T3_x = X_m;
    T3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, T6_x, T6_y);
    T5_x = X_m;
    T5_y = Y_m;

    center(T1_x, T1_y, T5_x, T5_y, T2_x, T2_y, T6_x, T6_y);
    C4_x = X_m;
    C4_y = Y_m;
    R4   = _z;
    R2   = R4+RAIL/2F;
    R6   = R4-RAIL/2F;
    
    P2_x = T2_x;
    P2_y = T2_y-_sign*magic(T1_x, T1_y, T2_x, T2_y, C4_x, C4_y)*R2;
    P4_x = T4_x;
    P4_y = T4_y-_sign*magic(T3_x, T3_y, T4_x, T4_y, C4_x, C4_y)*R4;
    P6_x = T6_x;
    P6_y = T6_y-_sign*magic(T5_x, T5_y, T6_x, T6_y, C4_x, C4_y)*R6;

    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P2_x, P2_y);
    P1_x = X_m;
    P1_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P4_x, P4_y);
    P3_x = X_m;
    P3_y = Y_m;
    symetrique(X_1_x, X_1_y, X_5_x, X_5_y, P6_x, P6_y);
    P5_x = X_m;
    P5_y = Y_m;
}
//////////////////////////////////////////////////////////////////////////// CalculFlexibleSgauche() ////////////////////////////////////////////////////////////////////////
void CalculFlexibleSgauche(int _c4, int _l4, int _b) {
    //--------------------------- points a gauche -----------------------
    X3_x = 0F;
    X3_y = MAILLE/2F;
    //--------------------------- points a droite ----------------------
    X4_x = MAILLE*(_c4+1F);
    X4_y = MAILLE*_l4+MAILLE/2F;
    //---------------------------- cercles et rayons ---------------------
    C3_x = 0F;
    C3_y = (-_b+MAILLE/sqrt(2F))/(sqrt(2F)-1F);
    R3   = -C3_y+MAILLE/2F;   
    C4_x = X4_x;
    R4   = (-X4_x+_b-X4_y)/(1-sqrt(2F));
    C4_y = X4_y+R4;    
    //--------------------------- points de tangence avec la ligne -----------------------
    X_3_x = R3/sqrt(2F);
    X_3_y = -X_3_x+_b;
    
    X_4_x = C4_x-R4/sqrt(2F);
    X_4_y = -X_4_x+_b;
    //--------------------------- tangente avec la ligne ou tangente entre les deux cecles ? --------------------
    if (X_3_x < X_4_x) {                                                    //  cas normal : on utilise les points de tangence avec la ligne
        T3_x = X_3_x;
        T3_y = X_3_y;
        T4_x = X_4_x;
        T4_y = X_4_y;
    } else {                                                                //  tangente entre cercles
        symetrique(C3_x, C3_y, C4_x, C4_y, X_3_x, X_3_y);
        T3_x = X_m;
        T3_y = Y_m;
        symetrique(C3_x, C3_y, C4_x, C4_y, X_4_x, X_4_y);
        T4_x = X_m;
        T4_y = Y_m;
    }
    //--------------------------- angles (qui sont les memes dans les deux cas) ---------------------------------
    alpha3 = asin(T3_x/R3);
    alpha4 = asin((X4_x-T4_x)/R4);
    //---------------------------- points magiques ------------------------------
    magic_points(T3_x, T3_y, T4_x, T4_y, C3_x, C3_y, C4_x, C4_y, R3, R4, X3_x, X3_y, X4_x, X4_y);
    P3g_x = Q1_x;
    P3g_y = Q1_y;
    P4d_x = Q2_x;
    P4d_y = Q2_y;
    P3_x  = magic(X3_x, X3_y, T3_x, T3_y, C3_x, C3_y)*R3;
    P3_y  = MAILLE/2F;    
    P4_x  = (_c4+1F)*MAILLE-magic(X4_x, X4_y, T4_x, T4_y, C4_x, C4_y)*R4;
    P4_y  = _l4*MAILLE+MAILLE/2F;    
}
//////////////////////////////////////////////////////////////////////////// CalculFlexibleSdroit() ////////////////////////////////////////////////////////////////////////
void CalculFlexibleSdroit(int _c4, int _l4, int _b) {
    //--------------------------- points a gauche -----------------------
    X3_x = 0F;
    X3_y = MAILLE/2F;
    //--------------------------- points a droite ----------------------
    X4_x = MAILLE*(_c4+1F);
    X4_y = MAILLE*_l4+MAILLE/2F;
    //---------------------------- cercles et rayons ---------------------
    C3_x = 0F;
    C3_y = (-_b+MAILLE/sqrt(2))/(sqrt(2)-1F);
    R3   = C3_y-MAILLE/2F;    
    C4_x = X4_x;
    R4   = (-X4_x-_b+X4_y)/(1-sqrt(2));
    C4_y = X4_y-R4;    
    //--------------------------- points de tangence avec la ligne -----------------------
    X_3_x = R3/sqrt(2);
    X_3_y = X_3_x+_b;    
    X_4_x = C4_x-R4/sqrt(2);
    X_4_y = X_4_x+_b;
    //--------------------------- tangente avec la ligne ou tangente entre les deux cecles ? --------------------
    if (X_3_x < X_4_x) {                                                    //  cas normal : on utilise les points de tangence avec la ligne
        T3_x = X_3_x;
        T3_y = X_3_y;
        T4_x = X_4_x;
        T4_y = X_4_y;
    } else {                                                                //  tangente entre cercles
        symetrique(C3_x, C3_y, C4_x, C4_y, X_3_x, X_3_y);
        T3_x = X_m;
        T3_y = Y_m;
        symetrique(C3_x, C3_y, C4_x, C4_y, X_4_x, X_4_y);
        T4_x = X_m;
        T4_y = Y_m;
    }
    //--------------------------- angles (qui sont les memes dans les deux cas) ---------------------------------
    alpha3 = asin(T3_x/R3);
    alpha4 = asin((X4_x-T4_x)/R4); //<>// //<>//
    //---------------------------- points magiques ------------------------------
    magic_points(T3_x, T3_y, T4_x, T4_y, C3_x, C3_y, C4_x, C4_y, R3, R4, X3_x, X3_y, X4_x, X4_y);
    P3g_x = Q1_x;
    P3g_y = Q1_y;
    P4d_x = Q2_x;
    P4d_y = Q2_y;
    P3_x  = magic(T3_x, T3_y, X3_x, X3_y, C3_x, C3_y)*R3;
    P3_y  = MAILLE/2F;    
    P4_x  = (_c4+1F)*MAILLE-magic(T4_x, T4_y, X4_x, X4_y, C4_x, C4_y)*R4;
    P4_y  = _l4*MAILLE+MAILLE/2F;
}
/////////////////////////////////////////////////////////////////////////////// CalculFlexibleSgauche45 //////////////////////////////////////////////////////////////////////////////////////////
void CalculFlexibleSgauche45(int _c4, int _l4, int _b) {
    //--------------------------- points a gauche -----------------------
    X3_x = 0F;
    X3_y = 0F;
    //--------------------------- points a droite ----------------------
    X4_x = MAILLE*_c4;
    X4_y = MAILLE*_l4;
    //---------------------------- cercles et rayons ---------------------
    float c = X4_y+X4_x;
    float A1 =  2F;
    float B1 = -4F*((c-_b)-X4_x)+4F*(_b-X4_y);
    float C1 =  2F*((c-_b)-X4_x)*((c-_b)-X4_x)+2F*(-_b+X4_y)*(-_b+X4_y);
    float delta1 = B1*B1-4F*A1*C1;
    R4 = (-B1+sqrt(delta1))/2F/A1;
    C4_x = (c-_b)-R4;
    C4_y = R4+_b;

    float A2 = 2F;
    float B2 = -8F*_b;
    float C2 = 4F*_b*_b;
    float delta2 = B2*B2-4F*A2*C2;
    R3 = (-B2+sqrt(delta2))/2F/A2;
    C3_x = R3-_b;
    C3_y = -C3_x;
    //--------------------------- points de tangence avec la ligne -----------------------
    X_3_x = C3_x;
    X_3_y = _b;    
    X_4_x = C4_x;
    X_4_y = _b;
    //--------------------------- tangente avec la ligne ou tangente entre les deux cecles ? --------------------
    if (X_3_x < X_4_x) {                                                    //  cas normal : on utilise les points de tangence avec la ligne
        T3_x = X_3_x;
        T3_y = X_3_y;
        T4_x = X_4_x;
        T4_y = X_4_y;
        //--------------------------- angles in normal case ---------------------------------
        alpha3 = asin(C3_x/R3);
        alpha4 = asin((X4_x-C4_x)/R4);
    } else {                                                                //  tangente entre cercles
        symetrique(C3_x, C3_y, C4_x, C4_y, X_3_x, X_3_y);
        T3_x = X_m;
        T3_y = Y_m;
        symetrique(C3_x, C3_y, C4_x, C4_y, X_4_x, X_4_y);
        T4_x = X_m;
        T4_y = Y_m;
        //--------------------------- angles quand il ya tangence entre cercles ---------------------------------
        alpha3 = PI/4-asin((C3_x-T3_x)/R3);
        alpha4 = PI/4-asin((T4_x-C4_x)/R4);
    }
    //---------------------------- points magiques ------------------------------
    magic_points(T3_x, T3_y, T4_x, T4_y, C3_x, C3_y, C4_x, C4_y, R3, R4, X3_x, X3_y, X4_x, X4_y);
    P3g_x = Q1_x;
    P3g_y = Q1_y;
    P4d_x = Q2_x;
    P4d_y = Q2_y;
    P3_x   = X3_x+magic(X3_x, X3_y, T3_x, T3_y, C3_x, C3_y)*R3/sqrt(2);
    P3_y   = X3_y+magic(X3_x, X3_y, T3_x, T3_y, C3_x, C3_y)*R3/sqrt(2);
    P4_x   = X4_x-magic(X4_x, X4_y, T4_x, T4_y, C4_x, C4_y)*R4/sqrt(2);
    P4_y   = X4_y-magic(X4_x, X4_y, T4_x, T4_y, C4_x, C4_y)*R4/sqrt(2);
} //<>//
/////////////////////////////////////////////////////////////////////////////// CalculFlexibleSdroit45 //////////////////////////////////////////////////////////////////////////////////////////
void CalculFlexibleSdroit45(int _c4, int _l4, int _b) {
    //--------------------------- points a gauche -----------------------
    X3_x = 0F;
    X3_y = 0F;
    //--------------------------- points a droite ----------------------
    X4_x = MAILLE*_c4;
    X4_y = MAILLE*_l4;
    //---------------------------- cercles et rayons ---------------------
    float c = X4_x+X4_y;
    float A1 = 2;
    float B1 = -4F*((c-_b)-X4_y)+4*(_b-X4_x);
    float C1 = 2*((c-_b)-X4_y)*((c-_b)-X4_y)+2*(-_b+X4_x)*(-_b+X4_x);
    float delta1 = B1*B1-4F*A1*C1;
    R4 = (-B1+sqrt(delta1))/2F/A1;
    C4_x = R4+_b;
    C4_y = (c-_b)-R4;
    float A2 = 2;
    float B2 = -8*_b;
    float C2 = 4*_b*_b;
    float delta2 = B2*B2-4F*A2*C2;
    R3 = (-B2+sqrt(delta2))/2F/A2;
    C3_x = -C3_y;
    C3_y = R3-_b;    
    R1   = R3+RAIL/2F;
    R5   = R3-RAIL/2F;
    R2   = R4-RAIL/2F;
    R6   = R4+RAIL/2F;
    //--------------------------- points de tangence avec la ligne -----------------------
    X_3_x = _b;
    X_3_y = C3_y;    
    X_4_x = _b;
    X_4_y = C4_y;
    //--------------------------- tangente avec la ligne ou tangente entre les deux cecles ? --------------------
    if (X_3_y <= X_4_y) {                                                    //  cas normal : on utilise les points de tangence avec la ligne
        T3_x = X_3_x;
        T3_y = X_3_y;
        T4_x = X_4_x;
        T4_y = X_4_y;
        //--------------------------- angles in normal case ---------------------------------
        alpha3 = asin(C3_y/R3);
        alpha4 = asin((X4_y-C4_y)/R4);
    } else {                                                                //  tangente entre cercles
        symetrique(C3_x, C3_y, C4_x, C4_y, X_3_x, X_3_y);
        T3_x = X_m;
        T3_y = Y_m;
        symetrique(C3_x, C3_y, C4_x, C4_y, X_4_x, X_4_y);
        T4_x = X_m;
        T4_y = Y_m;
        //--------------------------- angles quand il ya tangence entre cercles ---------------------------------
        alpha3 = PI/4-asin((C3_y-T3_y)/R3);
        alpha4 = PI/4-asin((T4_y-C4_y)/R4);
    }
    //---------------------------- points magiques ------------------------------
    magic_points(T3_y, T3_x, T4_y, T4_x, C3_y, C3_x, C4_y, C4_x, R3, R4, X3_y, X3_x, X4_y, X4_x);
    P3g_x = Q1_y;
    P3g_y = Q1_x;
    P4d_x = Q2_y;
    P4d_y = Q2_x;
    P3_x   = X3_x-magic(X3_x, X3_y, T3_x, T3_y, C3_x, C3_y)*R3/sqrt(2);
    P3_y   = X3_y-magic(X3_x, X3_y, T3_x, T3_y, C3_x, C3_y)*R3/sqrt(2);
    P4_x   = X4_x+magic(X4_x, X4_y, T4_x, T4_y, C4_x, C4_y)*R4/sqrt(2);
    P4_y   = X4_y+magic(X4_x, X4_y, T4_x, T4_y, C4_x, C4_y)*R4/sqrt(2);
}
//------------------------------------- calcul du nombre magique pour n'importe quel angle ---------------------------------------
float magic(float _x1, float _y1, float _x4, float _y4, float _xc, float _yc) {
    float ax = _x1-_xc;
    float ay = -(_y1-_yc);
    float bx = _x4-_xc;
    float by = -(_y4-_yc);
    float q1 = ax*ax+ay*ay;
    float q2 = q1+ax*bx+ay*by;
    float k = (4F/3F)*(sqrt(2*q1*q2)-q2)/(ax*by-ay*bx);
    return k;
}

//-------------------------------------- calcul des nombres magiques pour les points mediants -----------------------------------------
void magic_points(float _T1_x, float _T1_y, float _T2_x, float _T2_y, float _C1_x, float _C1_y, float _C2_x, float _C2_y, float _R1, float _R2, float _X1_x, float _X1_y, float _X2_x, float _X2_y) {
    float a12     = (_T2_y-_T1_y)/(_T2_x-_T1_x);
    float b12     = _T1_y-a12*_T1_x;
    
    float A1      = 1+a12*a12;
    float B1      = -2*_T1_x-2*_T1_y*a12+2*b12*a12;
    float C1      = _T1_x*_T1_x+(_T1_y-b12)*(_T1_y-b12)-_R1*_R1*magic(_T1_x, _T1_y, _X1_x, _X1_y, _C1_x, _C1_y)*magic(_T1_x, _T1_y, _X1_x, _X1_y, _C1_x, _C1_y);
    float delta1  = B1*B1-4F*A1*C1;
    Q1_x          = (-B1-sqrt(delta1))/2F/A1;
    Q1_y          = a12*((-B1-sqrt(delta1))/2F/A1)+b12;
    
    float A2      = 1+a12*a12;
    float B2      = -2*_T2_x-2*_T2_y*a12+2*b12*a12;
    float C2      = _T2_x*_T2_x+(_T2_y-b12)*(_T2_y-b12)-_R2*_R2*magic(_X2_x, _X2_y, _T2_x, _T2_y, _C2_x, _C2_y)*magic(_X2_x, _X2_y, _T2_x, _T2_y, _C2_x, _C2_y);
    float delta2  = B2*B2-4F*A2*C2;
    Q2_x          = (-B2+sqrt(delta2))/2F/A2;
    Q2_y          = a12*(-B2+sqrt(delta2))/2F/A2 +b12;
}

//------------------------------------ symetrique ----------------------------------------------------------------------------------
//  Calcule le symetrique d'un point M (Xm, Ym) par rapport a une droite passant par A (XA, YA) et B (XB, YB)
void symetrique(float XA, float YA, float XB, float YB, float Xm, float Ym) {
    float a = -(YB - YA);
    float b = (XB - XA);
    float c = -a*XA - b*YA;
    X_m = Xm - 2*a*(c+(a*Xm+b*Ym))/(a*a+b*b);
    Y_m = Ym - 2*b*(c+(a*Xm+b*Ym))/(a*a+b*b);
}

//---------------------------------- center --------------------------------------------------------------------------------
//  Resout un systeme de deux equations a deux inconnues par la methode de Cramer (point commun a deux droites)
void center(float XA, float YA, float XB, float YB, float XC, float YC, float XD, float YD) {
    float a1 = -(YB - YA);
    float b1 = (XB - XA);
    float c1 = -a1*XA - b1*YA;
    
    float a2 = -(YD - YC);
    float b2 = (XD - XC);
    float c2 = -a2*XC - b2*YC;
    
    float delta = a1*b2-a2*b1;
    X_m = -(c1*b2-b1*c2)/delta;
    Y_m = -(a1*c2-a2*c1)/delta;
}
