TCO        tco;
Palette    palette;
Pave       pave;
Pave       paveMouse;
Pave       paveCL;
Pave       pave_selectionne;
Pave       pave_CL;
Pave       pavePont;
Pave[][]   paves;
ascenseurV curseurV;
ascenseurH curseurH;
PShape pont;

ArrayList<Pave>       tous_paves     = new ArrayList<Pave>();
ArrayList<Pave>       tous_paves0    = new ArrayList<Pave>();                                                                                     //  liste de tous les pavés, sur le niveau 0
ArrayList<Pave>       tous_paves1    = new ArrayList<Pave>();                                                                                     //  liste de tous les pavés, sur le niveau 1
ArrayList<Pave>       paves_volants  = new ArrayList<Pave>();                                                                                     //  liste de tous les pavés volants
ArrayList<Pave>       tous_signaux   = new ArrayList<Pave>();                                                                                     //  liste de tous les pavé avec signal, sur les 2 niveaux

//////////////////////////////////////////// setup() /////////////////////////////////////////////////////////////////////////
void setup() {
    size(1366, 768, P2D);
    colorMode(RGB, 255, 255, 255);
    noStroke();
    tco         = new TCO();   
    palette     = new Palette();
    //point       = new Point();
    zoom_change = 2;
    //------------------------ Selection du fichier au demarrage ----------------------
    selectInput("Selectionnez un fichier pour determiner le repertoire de demarrage : ", "fileSelected");
    //------------------------ Creation des tables ---------------------------------------
    creation_table_TCO();
    for (int index = 0; index < INDEX_MAX; index++) {
        premier[index] = new PVector();
    }    
    //------------------------ Fontes pour les textes ---------------------    
    f = createFont("Courier New Bold",12,true);
    textSize(12);  
    //------------------------ Instanciations des ascenseurs --------------
    curseurV = new ascenseurV(largeur,        0, CURSEUR, hauteur, 1, couleur_bords, couleur_fond_barre, couleur_curseur, couleur_au_dessus_barre, couleur_curseur_presse);
    curseurH = new ascenseurH(      0,  hauteur, largeur, CURSEUR, 1, couleur_bords, couleur_fond_barre, couleur_curseur, couleur_au_dessus_barre, couleur_curseur_presse);
    charge_images();    
    one_shot            = true;
    deplacement_palette = false;
    width_precedent     = width;
}

/////////////////////////////////// draw() ///////////////////////////////////////////////////////////
void draw() {    
    if (tables_construites) {
        if (!deplacement_palette) {
            if (one_shot || width != width_precedent) {
                fill(FOND);
                rect(0, 0, width, height);                                                                                                            // efface le TCO
                ecran      = createImage(width, height, RGB);
                //image(fond_ecran, 0, 0, width, height);
                switch (niveau) {
                    case 0:
                        //---------------------------- cas normal (finit avec niveau = 0) -------------------
                        bordure_x = BORDURE_X;
                        bordure_y = BORDURE_Y;
                        niveau    = 1;
                        l_start   = L_MAX;
                        l_stop    = 2*L_MAX;
                        tco.dessine_tco();
                        bordure_x = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                        bordure_y = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                        niveau    = 0;
                        l_start   = 0;
                        l_stop    = L_MAX;
                        break;
                    case 1:
                        //---------------------------- cas + Alt (finit avec niveau = 1) -------------------
                        bordure_x = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                        bordure_y = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                        niveau    = 0;
                        l_start   = 0;
                        l_stop    = L_MAX;
                        tco.dessine_tco();
                        bordure_x = BORDURE_X;
                        bordure_y = BORDURE_Y;
                        niveau    = 1;
                        l_start   = L_MAX;
                        l_stop    = 2*L_MAX;
                        break;
                    default:
                }
                tco.dessine_tco();
                tco.maj_signaux();                                                                                                                    //  mise à jour des signaux pour le premier ecran
                tco.dessine_feux_tco();                                                                                                               //  dessine tous les feux
                tco.dessine_grille();
                tous_paves0.clear();
                tous_paves1.clear();
                for (Pave pave : tous_paves) {
                    if (pave.l < L_MAX) {
                        tous_paves0.add(tco.paves[pave.c][pave.l]);                                                                                   //  ajoute tous les pavés dans la liste "tous_paves0"
                    } else {
                        tous_paves1.add(tco.paves[pave.c][pave.l]);                                                                                   //  ajoute tous les pavés dans la liste "tous_paves1"
                    }
                }
                palette.dessine_palette();
                affiche_origine2();
                width_precedent = width;
                //------------ calcule l'image du fond d'ecran ---------------------
                ecran.loadPixels();                                                                                                                   //  prépare la variable écran
                loadPixels();                                                                                                                         //  charge l'écran complet dans la variable Pixels()
                for (int i = 0; i < pixels.length; i++) {
                    ecran.pixels[i] = pixels[i];                                                                                                      //  prépare la copie tous les pixels de l'écran dans la variable écran                                                                                               
                }
                ecran.updatePixels();                                                                                                                 //  met à jours la variable écran. A noter que cette variable écran n'a pas de trains
                one_shot = false;
            } else {
                image(ecran, 0, 0, width, height);
            }
        } else {
            image(ecran, 0, 0, width, height);                                                                                                        //  redessine tout le réseau avant d'afficher le pupitre
            palette.deplace_palette();                                                                                                                //  dessine la palette quand elle est en train de se deplacer
            one_shot         = true;
        }
        tco.deplace_pave();                                                                                                                           //  dessine le pavé quand il est en train de se deplacer
        largeur  = width -CURSEUR;                                                                                                                    //  mise a jour des ascenseurs
        hauteur  = height-CURSEUR;
        curseurV.mise_a_jour();
        curseurV.affiche_barre();
        l_min = -int(L_MAX*curseurV.position_en_valeur()/2);        
        curseurH.mise_a_jour();
        curseurH.affiche_barre();
        c_min = -int(C_MAX*curseurH.position_en_valeur()/2);
        menu();                                                                                                                                       //  affiche le menu
        affiche_origine1();
        if (zone_traitee != null) {
            zone_traitee.ID_zone_suite();
        }
        if (aide) { 
            image(texte_aide,  100, 10, largeur_texte, hauteur_texte);
        }
    }
}
