//******************************************************************* Menu **********************************************************************************
void menu() {
    if ((mouseX < width-CURSEUR-2 && (mouseY >= height-150 /*&& mouseY < height-2-CURSEUR*/)) || aide) {
        stroke(0);
        fill(FOND);
        quad(80F, height-30F-CURSEUR, width-80F, height-30F-CURSEUR, width-50F, height-10F-CURSEUR, 50F, height-10F-CURSEUR);       
        fill(BLANC);
        rect(50F, height-10F-CURSEUR, width-100F, 5F);
        
        int     nombre_boutons = 16;
        float   premiere_icone = 300F;
        float[] loupe          = new float[50];                                                                    //  loupe[], c'est le coefficient de grossissement de chaque bouton
        float[] emplacement    = new float[50];
        float   somme_nombres  = 0F;                                                                               //  largeur totale, c'est la somme des largeurs de tous les boutons
        float   curseur_loupe  = (mouseX-premiere_icone)/(width-2F*premiere_icone);                                //  curseur_loupe, c'est un nombre ramene a l'intervalle [0-1] en partant de [50, Width-50]
        int     nombre_petits  = 0;                                                                                //  nombre_petits, c'est le nombre de boutons de largeur_un
        if (curseur_loupe < 0) { curseur_loupe = 0; }
        if (curseur_loupe > 1) { curseur_loupe = 1; }
        curseur_loupe = curseur_loupe*(nombre_boutons);
        //--------------------------------------------------- calcul courbe de Gauss ----------------------------------------------------
        float sigma = 2F;
        for (int ordre_bouton = 0; ordre_bouton < nombre_boutons; ordre_bouton++) {
            loupe[ordre_bouton] = (2F/sigma)*exp(-(ordre_bouton+1-curseur_loupe)*(ordre_bouton+1-curseur_loupe)/4F/sigma/sigma)+1F;
            somme_nombres = somme_nombres+loupe[ordre_bouton];
            if (loupe[ordre_bouton] < 1.01F) { nombre_petits = nombre_petits+1; }
        }
        //------------------------------------------------ petits et gros boutons -------------------------------------------------------
        int     debut_gros = 0;
        int     fin_gros   = 0;
        boolean debut      = false;        
        fill(0);
        for (int ordre_bouton = 0; ordre_bouton < nombre_boutons; ordre_bouton++) {
            if (loupe[ordre_bouton] < 1.01F) {
                if (debut) {
                    fin_gros = ordre_bouton;
                    break;
                } else {
                    debut_gros = ordre_bouton;
                }
            } else {
                debut = true;
            }
        }
        if (fin_gros == 0) { fin_gros = nombre_boutons-1; }
        nombre_petits = nombre_boutons-(fin_gros-debut_gros+1);
        //------------------------------------ dessin des boutons ---------------------------------------------------------------------------
        float coeff_intervalle   = 1.1F;                                                                           //  l'intervalle correspond a 10 pour cent de la largeur d'un bouton
        float largeur_petit      = 0.3F*(width-2F*premiere_icone)/nombre_boutons;                                  //  largeur_bouton, c'est la largeur d'un bouton de largeur_des_petits
        float largeur_des_petits = largeur_petit*nombre_petits*coeff_intervalle;                                   //  largeur_des_petits, c'est la largeur du plus petit bouton * son coeff_intervalle
        float largeur_des_gros   = (width-2F*premiere_icone)-largeur_des_petits;                                   //  largeur_gros, c'est la largeur totale de l'emplacement des gros bouton
        float largeur_gros       = largeur_des_gros/(somme_nombres-nombre_petits)/coeff_intervalle;                //  intervalle, c'est la largeur (variable) entre les gros boutons
        float emplacement_bouton = premiere_icone;
        for (int ordre_bouton = 0; ordre_bouton < nombre_boutons; ordre_bouton++) {
            emplacement[ordre_bouton] = emplacement_bouton;
            if (ordre_bouton < debut_gros || ordre_bouton > fin_gros) {                                            //  petits boutons
                emplacement_bouton = emplacement_bouton+largeur_petit*coeff_intervalle;
            } else {                                                                                               //  gros boutons
                emplacement_bouton = emplacement_bouton+loupe[ordre_bouton]*largeur_gros*coeff_intervalle;
            }
        }
        emplacement[nombre_boutons] = emplacement_bouton;
        for (int ordre_bouton = 0; ordre_bouton < nombre_boutons; ordre_bouton++) {
            if (ordre_bouton < debut_gros || ordre_bouton > fin_gros) {                                            //  petits boutons
                image(fond_bouton[ordre_bouton],  emplacement[ordre_bouton],   height-26F-CURSEUR-largeur_petit,  largeur_petit,   largeur_petit);
                image(ombre_bouton[ordre_bouton], emplacement[ordre_bouton],   height-22F-CURSEUR,                largeur_petit,   10F);
            } else {                                                                                               //  gros boutons
                image(fond_bouton[ordre_bouton],  emplacement[ordre_bouton],   height-26F-CURSEUR-largeur_gros*loupe[ordre_bouton],   largeur_gros*loupe[ordre_bouton],   largeur_gros*loupe[ordre_bouton]);
                image(ombre_bouton[ordre_bouton], emplacement[ordre_bouton],   height-22F-CURSEUR,                                    largeur_gros*loupe[ordre_bouton],   10F);
            }
            if ((mouseX > emplacement[ordre_bouton] && mouseX < emplacement[ordre_bouton+1]) && (mouseY >= height-150 && mouseY < height-2-CURSEUR)){
                position_bouton = ordre_bouton;
            }                                                                                                      //  la position bouton est l'ordre du bouton pour les clics
        }
        noStroke();
    }
}
//------------------ key_zoom() --------------------
void key_zoom() {
    if (affiche_grille) {                                                                                          //  la grille est affichee. Si la grille n'est pas affichee, aucun zoom n'est possible                                                                                                   
        if (mode_selection) {                                                                                      //  on est dans le mode sélection. Ce mode est prioritaire.
            int total = 0;                                                                                         //  on va compter le nombre de pavés sélectionnes
            for (int c1 = 0; c1 < C_MAX; c1++) {
                for (int l1 = l_start; l1 < l_stop; l1++) {
                    paveCL = tco.paves[c1][l1];
                    if (paveCL != null && paveCL.selectionne) {
                        pave_selectionne = paveCL;
                        total++;
                    }
                }
            }
            if (total != 0) {                                                                                      //  il y a au moins un pavé sélectionne
                if (total == 1) {
                    if (pave_selectionne.deformable) {
                        pave_selectionne.elongation = max(1,int(pave_selectionne.elongation+zoom_change));
                        zoom_change       = 0;
                        one_shot = true;
                    } else {                                                                                       //  on ne peut zoomer qu'un pavé deformable
                        showMessageDialog(null, "Ce pavé n'est pas deformable",
                                                "Attention", ERROR_MESSAGE);
                    }
                } else {                                                                                           //  on ne peut zoomer qu'un seul pavé
                    showMessageDialog(null, "On ne peut allonger/retrecir qu'un seul pavé a la fois",
                                            "Attention", ERROR_MESSAGE);
                }
            } else {                                                                                               //  aucun pavé n'est sélectionne
            }
        } else {                                                                                                   //  on n'est pas en mode sélection, la palette est affichee : on peut agrandir/retrecir la palette
            if (affiche_palette) {                                                                                 //  la palette est affichee : le zoom s'applique a elle si on n'est pas sur un pavé
                int x_mouse = mouseX;
                int y_mouse = mouseY;
                int c_mouse = int((x_mouse-bordure_x)/MAILLE/zoom_x-c_min);
                int l_mouse = int((y_mouse-bordure_y)/MAILLE/zoom_y-l_min+niveau*L_MAX);
                paveMouse = tco.paves[c_mouse][l_mouse];
                if (paveMouse != null) {                                                                           //  on est sur un pavé : ce sont les formes du pavé qui sont deformees
                    paveMouse.elongation = max(1,int(paveMouse.elongation+zoom_change));
                    zoom_change     = 0;
                } else {                                                                                           //  on est en dehors d'un pavé : c'est la palette qui est zoomee
                    palette.zoom_p = max(3,int(palette.zoom_p+zoom_change));
                    zoom_change = 0;                  
                }
            } else {
                zoom_x = max(1,int(zoom_x+zoom_change));
                zoom_y = max(1,int(zoom_y+zoom_change));
                zoom_change = 0;
            }
        }
    }
    one_shot = true;
}

//--------------------------- unselect_all() ---------------------------
void unselect_all() {
    for (Pave pave1 : tous_paves) {
        pave1.selectionne = false;
    }  
}
//-------------------------------------------------------------------------- Key() -------------------------------------------------------
void keyPressed() {
    if (key != CODED) {
        switch (key) {
            //------------------ recherche du signal suivant et precedent --------------
            case 'd':
                break;
            case 'D':
                etiquettes_pont = !etiquettes_pont;
                one_shot        = true;
                break;
            case 'G':  //------------------ grille --------------
                affiche_coordonnees = !affiche_coordonnees;
                one_shot = true;
                break;
            case 's' :
            case 'S' :
                if (!mode_selection) {                                                                             //  set in select mode
                    mode_selection = true;
                    unselect_all();
                    cursor(CROSS);
                } else {                                                                                           // set in unselect mode
                    unselect_all();
                    mode_selection    = false;
                    mode_flexible     = false;
                    voie_pont_tournant_posee   = false;
                    cursor(ARROW);
                    one_shot = true;
                }
                break;
            case 'T':  //------------------ tourne la plaque --------------------------
                theta = theta-0.0130899F;
                one_shot = true;
                break;
            case 't':
                theta = theta+0.0130899F;
                one_shot = true;
                break;
        }
    }
}

//****************************************** ascenseur horizontal ******************************************************
class ascenseurH {
    
    int     largeur_barre, hauteur_barre;                                                         //  largeur et hauteur de la barre. NOTE: hauteur_barre est aussi utilise comme largeur du curseur.
    int     Xpos, Ypos;                                                                           //  position X, Y du coin superieur gauche de la barre
    float   Cpos, newCpos;                                                                        //  position X (gauche) du curseur
    int     Cpos_min, Cpos_max;                                                                   //  valeurs min et max des positions du curseur
    int     inertie;                                                                              //  inertie du curseur
    boolean au_dessus;                                                                            //  true si la souris est au dessus de la barre
    boolean bloque;                                                                               //  true si on appuie sur le curseur
    color   couleur_bords;
    color   couleur_fond_barre;
    color   couleur_au_dessus_barre;
    color   couleur_curseur;
    color   couleur_curseur_presse;
  
    ascenseurH (int _X_debut, int _Y_debut, int _largeur_barre, int _hauteur_barre, int _inertie,
                color _couleur_bords, color _couleur_fond_barre, color _couleur_curseur, color _couleur_au_dessus_barre, color _couleur_curseur_presse) {
        largeur_barre = _largeur_barre;
        hauteur_barre = _hauteur_barre;
        Xpos          = _X_debut;
        Ypos          = _Y_debut;
        Cpos          = 0;                                                                       //  initialement a gauche
        newCpos       = Cpos;
        Cpos_min      = Xpos;
        Cpos_max      = Xpos + largeur_barre - hauteur_barre;
        inertie       = _inertie;
        if (inertie < 1) { inertie = 1; }
        
        couleur_bords           = _couleur_bords;
        couleur_fond_barre      = _couleur_fond_barre;
        couleur_curseur         = _couleur_curseur;
        couleur_au_dessus_barre = _couleur_au_dessus_barre;
        couleur_curseur_presse  = _couleur_curseur_presse;
    }  //  constructeur
    //--------------------------- mise_a_jour() position du curseur ----------------------------------
    void mise_a_jour() {
        Xpos          = 0;
        Ypos          = hauteur;
        largeur_barre = largeur;
        hauteur_barre = CURSEUR;
        Cpos_min      = 0;
        Cpos_max      = largeur-CURSEUR;
        au_dessus     = au_dessus();
        if (mousePressed && au_dessus) {
            one_shot         = true;
            bloque    = true;
        } else {
            bloque    = false;
        }    
        if (bloque) {
            newCpos   = constrain(mouseX-hauteur_barre/2, Cpos_min, Cpos_max);
        }       
        if(abs(newCpos - Cpos) > 0) {
            Cpos      = Cpos + (newCpos-Cpos)/inertie;
        }
    }
    //----------------------------- recadrage position curseur ---------------------------------------
    int constrain(int val, int minv, int maxv) {
        return min(max(val, minv), maxv);
    }
    //------------------------------ au_dessus() de la barre -----------------------------------------
    boolean au_dessus() {
        if(mouseX > Xpos && mouseX < Xpos+largeur_barre && mouseY > Ypos && mouseY < Ypos+hauteur_barre) {
            return true;
        } else {
            return false;
        }
    }
    //------------------------------- affiche_barre() -----------------------------------------------------
    void affiche_barre() {
        stroke(couleur_bords);
        fill(couleur_fond_barre);
        rect(Xpos, Ypos, largeur_barre, hauteur_barre);
        if (au_dessus) {
            fill(couleur_au_dessus_barre);
        }
        if (bloque) {
            fill(couleur_curseur_presse);
        }
        if (!au_dessus && !bloque) {
            fill (couleur_curseur);
        }
        if (abs(Cpos-newCpos)>0.1) { fill (couleur_curseur_presse); }
        rect(Cpos, Ypos, hauteur_barre, hauteur_barre);
    }
    //------------------------------ position_en_valeur() --------------------------------------------------
    //  convertit la position du curseur en une valeur entre 0 et 1
    float position_en_valeur() {
        return (Cpos-Xpos) / (largeur_barre-hauteur_barre);
    }
    //------------------------------- valeur_en_position() -------------------------------------------------
    // convertit une valeur entre 0 et 1 en une position du curseur
    void valeur_en_position(float _valeur) {
        if (_valeur < 0) { _valeur = 0; }
        if (_valeur > 1) { _valeur = 1; }
        Cpos    = Xpos + ((largeur_barre-hauteur_barre)*_valeur);
        newCpos = Cpos;
    }
}

//*************************************** ascenseur vertical *******************************************************************************
class ascenseurV {
    int     largeur_barre, hauteur_barre;                                                         //  largeur et hauteur de la barre. NOTE: hauteur_barre est aussi utilise comme hauteur du curseur.
    int     Xpos, Ypos;                                                                           //  position X, Y du coin superieur gauche de la barre
    float   Cpos, newCpos;                                                                        //  position X (haut) du curseur
    int     Cpos_min, Cpos_max;                                                                   //  valeurs min et max des positions du curseur
    int     inertie;                                                                              //  inertie du curseur
    boolean au_dessus;                                                                            //  true si la souris est au dessus de la barre
    boolean bloque;                                                                               //  true si on appuie sur le curseur
    color   couleur_bords;
    color   couleur_fond_barre;
    color   couleur_au_dessus_barre;
    color   couleur_curseur;
    color   couleur_curseur_presse;
  
    ascenseurV (int _X_debut, int _Y_debut, int _largeur_barre, int _hauteur_barre, int _inertie,
                color _couleur_bords, color _couleur_fond_barre, color _couleur_curseur, color _couleur_au_dessus_barre, color _couleur_curseur_presse) {
      largeur_barre = _largeur_barre;
      hauteur_barre = _hauteur_barre;
      Xpos          = _X_debut;
      Ypos          = _Y_debut;
      Cpos          = 0;                                                                          // initialement en haut
      newCpos       = Cpos;
      Cpos_min      = 0;
      Cpos_max      = hauteur-CURSEUR;
      inertie       = _inertie;
      if (inertie < 1) { inertie = 1; }
      couleur_bords           = _couleur_bords;
      couleur_fond_barre      = _couleur_fond_barre;
      couleur_curseur         = _couleur_curseur;
      couleur_au_dessus_barre = _couleur_au_dessus_barre;
      couleur_curseur_presse  = _couleur_curseur_presse;
    }
    //--------------------------- mise_a_jour() position du curseur ----------------------------------  
    void mise_a_jour() {
        Xpos          = largeur;
        Ypos          = 0;
        largeur_barre = CURSEUR;
        hauteur_barre = hauteur;
        Cpos_min      = Ypos;
        Cpos_max      = Ypos + hauteur_barre - largeur_barre;
        au_dessus     = au_dessus();
        if (mousePressed && au_dessus) {
            one_shot         = true;
            bloque    = true;
        } else {
            bloque    = false;
        }    
        if (bloque) {
            newCpos   = constrain(mouseY-largeur_barre/2, Cpos_min, Cpos_max);
        }
        if (abs(newCpos - Cpos) > 0) {
            Cpos      = Cpos + (newCpos-Cpos)/inertie;
        }
    }
    //----------------------------- recadrage position curseur ---------------------------------------  
    int constrain(int val, int minv, int maxv) {
        return min(max(val, minv), maxv);
    }
    //------------------------------ au_dessus() de la barre -----------------------------------------  
    boolean au_dessus() {
        if(mouseX > Xpos && mouseX < Xpos+largeur_barre && mouseY > Ypos && mouseY < Ypos+hauteur_barre) {
            return true;
        } else {
            return false;
        }
    }
    //------------------------------- affiche_barre() -----------------------------------------------------   
    void affiche_barre() {
        stroke(couleur_bords);
        fill(couleur_fond_barre);
        rect(Xpos, Ypos, largeur_barre, hauteur_barre);
        if (au_dessus) {
            fill(couleur_au_dessus_barre);
        }
        if (bloque) {
            fill(couleur_curseur_presse);
        }
        if (!au_dessus && !bloque) {
            fill (couleur_curseur);
        }
        if (abs(Cpos-newCpos)>0.1) { fill (couleur_curseur_presse); }
        rect(Xpos, Cpos, largeur_barre, largeur_barre);
    }
    //------------------------------ position_en_valeur() --------------------------------------------------
    //  convertit la position du curseur en une valeur entre 0 et 1  
    float position_en_valeur() {
        return (Cpos-Ypos) / (hauteur_barre-largeur_barre);
    }
    //------------------------------- valeur_en_position() -------------------------------------------------
    // convertit une valeur entre 0 et 1 en une position du curseur   
    void valeur_en_position(float _valeur) {
        if (_valeur < 0) { _valeur = 0; }
        if (_valeur > 1) { _valeur = 1; }
        Cpos = Ypos + ((hauteur_barre-largeur_barre)*_valeur);
        newCpos = Cpos;
    }
}
