class Palette {
    final Pave[][] palettes = new Pave[C_MAX][2*L_MAX];
    Pave palette;
    
    int c_max_p = 2;                                                                                                                              // nombre de colonnes de la palette
    int l_max_p = 11;                                                                                                                             // taille de la colonne de la palette
    
    int     zoom_p = 3;                                                                                                                           //  zoom_palette
    int     volet  = 1;                                                                                                                           //  volet de la palette au debut (1 = ouvert, 0 = ferme)
                                                                                                                                                  //  ce n'est pas un booleen car on se sert de cette valeur pour les dimensions de la palette
    boolean in_palette  = false;                                                                                                                  //  la souris est dans la palette
    boolean selectionne = false;

    Palette() {
        palettes[0][0]  = new NullPave();
        palettes[1][0]  = new NullPave();
        palettes[0][1]  = new PaveDroit();
        palettes[1][1]  = new PaveButoir();
        palettes[0][2]  = new PaveArc45();
        palettes[1][2]  = new PaveArc90();
        palettes[0][3]  = new PaveFlexibleSdroit();
        palettes[1][3]  = new PaveFlexibleSgauche();
        palettes[0][6]  = new PaveVoiePont();
        palettes[1][6]  = new PavePont();
        palettes[0][7]  = new PaveCroisement45();
        palettes[1][7]  = new PaveCroisement90();
        palettes[0][8]  = new PaveAiguilleDroite();
        palettes[1][8]  = new PaveAiguilleGauche();
        palettes[0][9]  = new PaveTJS();
        palettes[1][9]  = new PaveTJD();
        palettes[0][10] = new PaveTriple();
        palettes[1][10] = new PaveSymetrique();
    }
        
    //------------------------------- dessine_palette() ------------------------------------------
    void dessine_palette() {   
        if (affiche_palette) {
            x_mouse_p = bordure_x+x_palette;                                                                                                      //  x du coin en haut a gauche de la palette
            y_mouse_p = bordure_y+y_palette;                                                                                                      //  y du coin en haut a gauche de la palette
            
            for (int c = 0; c < c_max_p; c++) {
                for (int l = 0; l < l_max_p; l++) {
                    palette = palettes[c][l];
                    if (palette != null) {
                        palette.lames = 0;
                        affiche_palette(c, l);
                    } else {
                        image(fond_pave, x_mouse_p+c*MAILLE*zoom_p, y_mouse_p+l*MAILLE*zoom_p, fond_pave.width*zoom_p*MAILLE/fond_pave_width, fond_pave.height*zoom_p*MAILLE/fond_pave_height);
                    }
                }
            }
        }
    }
    
    //--------------------------------- affiche_palette() ----------------------------------
    void affiche_palette(int _c, int _l) {
        if (niveau == 0) {
            palette.couleur_rail = BLEU1;
        } else {
            palette.couleur_rail = BLEU2;
        }
        if (_l == 0) {
            image(fond_pave, x_mouse_p, y_mouse_p, 2*fond_pave.width*zoom_p*MAILLE/fond_pave_width, fond_pave.height*zoom_p*MAILLE/fond_pave_height);
        } else {
            image(fond_pave, x_mouse_p+_c*MAILLE*zoom_p, y_mouse_p+_l*MAILLE*zoom_p, fond_pave.width*zoom_p*MAILLE/fond_pave_width, fond_pave.height*zoom_p*MAILLE/fond_pave_height);
        }
        pushMatrix();
            translate(x_mouse_p, y_mouse_p);
            if (_l == 3 && _c == 1) {                                                                                                             //  cas des flexibles
                translate((_c+.15)*MAILLE*zoom_p, (_l+.5)*MAILLE*zoom_p);
                scale(zoom_p*.35, zoom_p*.50);
            } else {
                if (_l == 3 && _c == 0) {
                    translate((_c+.15)*MAILLE*zoom_p, (_l)*MAILLE*zoom_p);
                    scale(zoom_p*.35, zoom_p*.50);
                } else {
                    if (_l == 6 && _c == 1) {                                                                                                     //  cas du pont tournant
                        translate((_c+.30)*MAILLE*zoom_p, (_l+.30)*MAILLE*zoom_p);
                        scale(zoom_p*.35, zoom_p*.35);
                    } else {                                                                                                                      //  cas normal
                        translate((_c+.15)*MAILLE*zoom_p, (_l+.15)*MAILLE*zoom_p);
                        scale(zoom_p*.7, zoom_p*.7);
                    }
                }
            }
            palette.dessine_pave_palette();
        popMatrix();
    }
    
    //------------------------------ test_palette() --------------------------------------
    void test_palette() {
        in_palette = false;
        x_mouse    = mouseX;
        y_mouse    = mouseY;
        x_offset_p = x_mouse-x_mouse_p;
        y_offset_p = y_mouse-y_mouse_p;
        if (affiche_palette) {
            if ((x_mouse >= x_mouse_p && x_mouse <= x_mouse_p+2*MAILLE*zoom_p)
             && (y_mouse >= y_mouse_p && y_mouse <= y_mouse_p+l_max_p*MAILLE*zoom_p)) {
                 in_palette = true;
            }
        }
    }
    
    //---------------------------- test_paveInPallet() -----------------------------------
    void pave_in_palette() {
        unselect_all();
        //                    +------+------+
        //                    | 0, 0 | 1, 0 |
        //                    +------+------+
        //                    | 0, 1 | 1, 1 |
        //                    +------+------+
        //                    | 0, 2 | 1, 2 |
        //                    +------+------+
        //                    | 0, 3 | 1, 3 |
        //                    +------+------+
        //                    | 0, 4 | 1, 4 |
        //                    +------+------+
        //                    | 0, 5 | 1, 5 |
        //                    +------+------+
        //                    | 0, 6 | 1, 6 |
        //                    +------+------+
        //                    | 0, 7 | 1, 7 |
        //                    +------+------+
        //                    | 0, 8 | 1, 8 |
        //                    +------+------+
        //                    | 0, 9 | 1, 9 |
        //                    +------+------+
        //                    | 0,10 | 1,10 |
        //                    +------+------+

        c_mouse = (x_mouse-bordure_x)/MAILLE/zoom_x;
        l_mouse = (y_mouse-bordure_y)/MAILLE/zoom_y;
        
        int colonne_palette = (x_mouse-x_mouse_p)/MAILLE/zoom_p;
        if (colonne_palette < 2) {                                                                                                                //  on est pas dans le volet, mais dans les pavés de la palette
            int ligne_palette = (y_mouse-y_mouse_p)/MAILLE/zoom_p;
            if (aide) {
                position_pave = 100*(colonne_palette+1)+(ligne_palette+1);                                                                        //  la position_pave sert pour l'aide
            } else {
                if (mousePressed && ligne_palette == 0) {                                                                                         //  on va deplacer la palette
                    if (!mode_selection) {
                        if (mouseButton == LEFT) {
                            deplacement_palette = true;
                            for (int c = 0; c < c_max_p; c++) {
                                for (int l = 0; l < l_max_p; l++) {
                                    palette = palettes[c][l];
                                    if (palette != null) { palette.selectionne = true; }
                                }
                            }
                        }
                    }
                } else {                                                                                                                          //  on va deplacer un pavé                    
                    if (mouseButton == LEFT && in_palette && !mode_selection) {
                        fill(FOND);
                        l_mouse = l_mouse+niveau*L_MAX;
                        if (!(colonne_palette == 1 && ligne_palette == 6)) {                                                                      //  je ne suis pas sur le pont tournant
                            tco.paves[c_mouse][l_mouse]             = palettes[colonne_palette][ligne_palette].copy();
                            tco.paves[c_mouse][l_mouse].selectionne = true;
                            tco.paves[c_mouse][l_mouse].ordre_tous_paves = tous_paves.size();
                            paves_volants.clear();
                            paves_volants.add(tco.paves[c_mouse][l_mouse]);
                            tous_paves.add(tco.paves[c_mouse][l_mouse]);
                            tco.paves[c_mouse][l_mouse]             = null;
                            deplacement                             = true;
                            theta                                   = 0;
                        } else {
                            if (!pont_tournant_pose) {
                                tco.paves[c_mouse][l_mouse]             = palettes[colonne_palette][ligne_palette].copy();
                                tco.paves[c_mouse][l_mouse].selectionne = true;
                                tco.paves[c_mouse][l_mouse].ordre_tous_paves = tous_paves.size();
                                paves_volants.clear();
                                paves_volants.add(tco.paves[c_mouse][l_mouse]);
                                tous_paves.add(tco.paves[c_mouse][l_mouse]);
                                tco.paves[c_mouse][l_mouse]             = null;
                                deplacement                             = true;
                                theta                                   = 0;
                            }
                        }
                    }
                }
            }
        }
    }
    
    //----------------------------- deplace_palette() --------------------------------------------------
    void deplace_palette() {
        if (deplacement_palette) {
            cursor(MOVE);
            for (int c = 0; c < c_max_p; c++) {
                for (int l = 0; l < l_max_p; l++) {
                    palette = palettes[c][l];
                    image(fond_pave, x_mouse_p+c*MAILLE*zoom_p, y_mouse_p+l*MAILLE*zoom_p, fond_pave.width*zoom_p*MAILLE/fond_pave_width, fond_pave.height*zoom_p*MAILLE/fond_pave_height);
                    x_mouse_p = mouseX-x_offset_p;
                    y_mouse_p = mouseY-y_offset_p;
                    if(palette != null && palette.selectionne) { 
                        affiche_palette(c, l);
                        if (!mousePressed) {
                            x_palette           = x_mouse_p-bordure_x;
                            y_palette           = y_mouse_p-bordure_y;
                            palette.selectionne = false;
                            deplacement_palette = false;
                            deplacement         = false;
                            cursor(ARROW);
                        }
                    }
                }
            }            
        }
        one_shot = true;
    }
}
