//******************************* Table_TCO ****************************************
//----------------------------- creation_table_TCO() ---------------------------------
void creation_table_TCO() {
    TCO = new Table();    
    TCO.addColumn("colonne");
    TCO.addColumn("ligne");
    TCO.addColumn("type");
    TCO.addColumn("elong");
    TCO.addColumn("orient");
    TCO.addColumn("retr00");
    TCO.addColumn("retr01");
    TCO.addColumn("retr02");
    TCO.addColumn("retr03");
    TCO.addColumn("retr10");
    TCO.addColumn("retr11");
    TCO.addColumn("retr12");
    TCO.addColumn("retr13");
    TCO.addColumn("cible0");
    TCO.addColumn("cible1");
    TCO.addColumn("cib_v0");
    TCO.addColumn("cib_v1");
    TCO.addColumn("lg_voie");
    TCO.addColumn("ht_voie");
    TCO.addColumn("ordre");
    TCO.addColumn("v_devie");
    TCO.addColumn("v_limit");
    TCO.addColumn("poids");
    TCO.addColumn("meca0");
    TCO.addColumn("meca1");
    TCO.addColumn("t_cib0");
    TCO.addColumn("t_cib1");
    TCO.addColumn("butoir0");
    TCO.addColumn("butoir1");
    TCO.addColumn("manoeuv");
    TCO.addColumn("ID_zone");
}

//----------------------------- charge_table_TCO() ------------------------------------
void charge_table_TCO() {  
    if (file_selected != null) {
        TCO = loadTable(file_selected, "header"); 
        for (TableRow row : TCO.rows()) {
            int     _c              = row.getInt("colonne");
            int     _l              = row.getInt("ligne");
            int     _type           = row.getInt("type");
            int     _elongation     = row.getInt("elong");
            int     _orientation    = row.getInt("orient");
            int     _retr00         = row.getInt("retr00");
            int     _retr01         = row.getInt("retr01");
            int     _retr02         = row.getInt("retr02");
            int     _retr03         = row.getInt("retr03");
            int     _retr10         = row.getInt("retr10");
            int     _retr11         = row.getInt("retr11");
            int     _retr12         = row.getInt("retr12");
            int     _retr13         = row.getInt("retr13");
            boolean _cible0         = boolean(row.getInt("cible0"));      
            boolean _cible1         = boolean(row.getInt("cible1"));      
            boolean _cib_v0         = boolean(row.getInt("cib_v0"));      
            boolean _cib_v1         = boolean(row.getInt("cib_v1"));      
            int     _longueur_voie  = row.getInt("lg_voie");
            int     _hauteur_voie   = row.getInt("ht_voie");
            int     _ordre          = row.getInt("ordre");
            int     _vitesse_deviee = row.getInt("v_devie");
            int     _vitesse_limite = row.getInt("v_limit");
            int     _poids          = row.getInt("poids");
            boolean _mecanique0     = boolean(row.getInt("meca0"));      
            boolean _mecanique1     = boolean(row.getInt("meca1"));      
            int     _type_cible0    = row.getInt("t_cib0");
            int     _type_cible1    = row.getInt("t_cib1");
            boolean _butoir0        = boolean(row.getInt("butoir0"));      
            boolean _butoir1        = boolean(row.getInt("butoir1"));           
            int     _manoeuvre      = row.getInt("manoeuv");
            String  _ID_zone        = row.getString("ID_zone");
            
            if (_type == -1) {                                              //  ligne d'informations
                zoom_x              = _c;
                zoom_y              = _l;
                palette.zoom_p      = _elongation;
                zoom_pupitre        = _orientation;
                x_palette           = _retr00;
                y_palette           = _retr01;
                x_pupitre           = _retr02;
                y_pupitre           = _retr03;
            }
    
            if (_type != -1 && !(_c == 0 && _l == 0)) {  //  normal types
                switch (_type) {
                    case 1:
                        tco.paves[_c][_l] = palette.palettes[0][1].copy();  //  PaveDroit
                        tco.paves[_c][_l].type = 1;
                        break;
                    case 2:
                        tco.paves[_c][_l] = palette.palettes[1][1].copy();  //  PaveButoir
                        tco.paves[_c][_l].type = 2;
                        break;
                    case 3:
                        tco.paves[_c][_l] = palette.palettes[0][2].copy();  //  PaveArc45
                        tco.paves[_c][_l].type = 3;
                        break;
                    case 4:
                        tco.paves[_c][_l] = palette.palettes[1][2].copy();  //  PaveArc90
                        tco.paves[_c][_l].type = 4;
                        break;
                    case 5:
                        tco.paves[_c][_l] = palette.palettes[0][3].copy();  //  PaveFlexibleSdroit
                        tco.paves[_c][_l].type = 5;
                        break;
                    case 6:
                        tco.paves[_c][_l] = palette.palettes[1][3].copy();  //  PaveFlexibleSgauche
                        tco.paves[_c][_l].type = 6;
                        break;
                    case 7:
                        break;
                    case 8:
                        break;
                    case 9:
                        break;
                    case 10:
                        break;
                    case 11:
                        tco.paves[_c][_l] = palette.palettes[1][6].copy();  //  PaveVoiePont
                        tco.paves[_c][_l].type = 11;
                        voie_pont_tournant_posee = false;
                        break;
                    case 12:
                        tco.paves[_c][_l] = palette.palettes[0][6].copy();  //  PavePont
                        tco.paves[_c][_l].type = 12;
                        
                        for (int i = 0; i < 160; i++) {
                            Pont[i] = 0;
                        }                            
                        int total_voies = _ordre;                 //  24 -> 24  32 -> 32  40 ->  40  48  ->  48
                        int valeur1     = total_voies/4;          //  24 -> 6   32 -> 8   40 ->  10  48  ->  12
                        int valeur2     = total_voies/8;          //  24 -> 3   32 -> 4   40 ->  5   48  ->  6
                        int valeur3     = total_voies+1-valeur2;  //  24 -> 22  32 -> 29  40 ->  36  48  ->  43
                        int valeur4     = valeur1+valeur2;        //  24 -> 9   32 -> 12  40 ->  15  48  ->  18
                        int valeur5     = valeur1+valeur4+1;      //  24 -> 16  32 -> 21  40 ->  26  48  ->  31                        
                        for (int i = 0; i < valeur1; i++) {
                            Pont[2*((valeur3+i) % total_voies)]   = c_mouse+valeur2;
                            Pont[2*((valeur3+i) % total_voies)+1] = l_mouse+valeur2-1-i;
                            if (i == (valeur2-1)) {
                                Pont[0]                           = c_mouse+valeur2;
                                Pont[1]                           = l_mouse;
                            }
                            Pont[2*(valeur4-i)]                   = c_mouse-valeur2+i;
                            Pont[2*(valeur4-i)+1]                 = l_mouse-valeur2;
                            Pont[2*(valeur4+1+i)]                 = c_mouse-valeur2;
                            Pont[2*(valeur4+1+i)+1]               = l_mouse-valeur2+1+i;
                            Pont[2*(valeur5+i)]                   = c_mouse-valeur2+1+i;
                            Pont[2*(valeur5+i)+1]                 = l_mouse+valeur2;
                        }                       
                        pont_tournant_pose = true;
                        break;
                    case 13:
                        tco.paves[_c][_l] = palette.palettes[0][7].copy();  //  PaveCroisement45
                        tco.paves[_c][_l].type = 13;
                        break;
                    case 14:
                        tco.paves[_c][_l] = palette.palettes[1][7].copy();  //  PaveCroisement90
                        tco.paves[_c][_l].type = 14;
                        break;
                    case 15:
                        tco.paves[_c][_l] = palette.palettes[0][8].copy();  //  PaveAiguilleDroite
                        tco.paves[_c][_l].type = 15;
                        break;
                    case 16:
                        tco.paves[_c][_l] = palette.palettes[1][8].copy();  //  PaveAiguilleGauche
                        tco.paves[_c][_l].type = 16;
                        break;
                    case 17:
                        tco.paves[_c][_l] = palette.palettes[0][9].copy();  //  PaveTJS
                        tco.paves[_c][_l].type = 17;
                        break;
                    case 18:
                        tco.paves[_c][_l] = palette.palettes[1][9].copy();  //  PaveTJD
                        tco.paves[_c][_l].type = 18;
                        break;
                    case 19:
                        tco.paves[_c][_l] = palette.palettes[0][10].copy();  //  PaveTriple
                        tco.paves[_c][_l].type = 19;
                        break;
                    case 20:
                        tco.paves[_c][_l] = palette.palettes[1][10].copy();  //  PaveSymetrique
                        tco.paves[_c][_l].type = 20;
                        break;
                }
                if (tco.paves[_c][_l] != null) {
                    tco.paves[_c][_l].c                  = _c;
                    tco.paves[_c][_l].l                  = _l;
                    tco.paves[_c][_l].elongation         = _elongation;
                    tco.paves[_c][_l].orientation        = _orientation;
                    tco.paves[_c][_l].connecteur[0][0].z = _retr00;
                    tco.paves[_c][_l].connecteur[0][1].z = _retr01;
                    tco.paves[_c][_l].connecteur[0][2].z = _retr02;
                    tco.paves[_c][_l].connecteur[0][3].z = _retr03;
                    tco.paves[_c][_l].connecteur[1][0].z = _retr10;
                    tco.paves[_c][_l].connecteur[1][1].z = _retr11;
                    tco.paves[_c][_l].connecteur[1][2].z = _retr12;
                    tco.paves[_c][_l].connecteur[1][3].z = _retr13;
                    tco.paves[_c][_l].cible[0]           = _cible0;
                    tco.paves[_c][_l].cible[1]           = _cible1;
                    tco.paves[_c][_l].cible_visible[0]   = _cib_v0;
                    tco.paves[_c][_l].cible_visible[1]   = _cib_v1;
                    tco.paves[_c][_l].longueur_voie      = _longueur_voie;
                    tco.paves[_c][_l].hauteur_voie       = _hauteur_voie;
                    tco.paves[_c][_l].ordre              = _ordre;
                    tco.paves[_c][_l].vitesse_deviee     = _vitesse_deviee;
                    tco.paves[_c][_l].vitesse_limite     = _vitesse_limite;
                    tco.paves[_c][_l].poids              = _poids;
                    tco.paves[_c][_l].mecanique[0]       = _mecanique0;
                    tco.paves[_c][_l].mecanique[1]       = _mecanique1;
                    tco.paves[_c][_l].type_cible[0]      = _type_cible0;
                    tco.paves[_c][_l].type_cible[1]      = _type_cible1;
                    tco.paves[_c][_l].butoir[0]          = _butoir0;
                    tco.paves[_c][_l].butoir[1]          = _butoir1;
                    tco.paves[_c][_l].manoeuvre          = _manoeuvre;
                    tco.paves[_c][_l].ID_zone            = _ID_zone;
                    tous_paves.add(tco.paves[_c][_l]);                                                                           //  ajoute tous les pavés non nuls dans la liste "tous_paves"
                    if (_l < L_MAX) {
                        tous_paves0.add(tco.paves[_c][_l]);                                                                      //  ajoute tous les pavés non nuls dans la liste "tous_paves0"
                    } else {
                        tous_paves1.add(tco.paves[_c][_l]);                                                                      //  ajoute tous les pavés non nuls dans la liste "tous_paves1"
                    }
                    if (tco.paves[_c][_l].cible[0] || tco.paves[_c][_l].cible[1]) {                                                                               //  s'il y a au moins une cible
                        tous_signaux.add(tco.paves[_c][_l]);                                                                                              //  ajoute le pavé dans la liste "cibles", liste des pavé avec signal
                    }
                }
            }
        }        
        tco.paves[0][0] = palette.palettes[0][0];
        one_shot           = true;
        tables_construites = true;
    }
}

//------------------------------ sauve_TCO() ---------------------------------------------------------
void sauve_TCO() {
    TCO.clearRows();    
    TableRow newRow = TCO.addRow();
    newRow.setInt("colonne"   , 0);
    newRow.setInt("ligne"     , 0);
    newRow.setInt("type"      , 0);
    newRow.setInt("elong"     , 0);
    newRow.setInt("orient"    , 0);
    newRow.setInt("retr00"    , 0);
    newRow.setInt("retr01"    , 0);
    newRow.setInt("retr02"    , 0);
    newRow.setInt("retr03"    , 0);
    newRow.setInt("retr10"    , 0);
    newRow.setInt("retr11"    , 0);
    newRow.setInt("retr12"    , 0);
    newRow.setInt("retr13"    , 0);
    newRow.setInt("cible0"    , 0);
    newRow.setInt("cible1"    , 0);
    newRow.setInt("cib_v0"    , 0);
    newRow.setInt("cib_v1"    , 0);
    newRow.setInt("lg_voie"   , 0);
    newRow.setInt("ht_voie"   , 0);
    newRow.setInt("ordre"     , 0);
    newRow.setInt("v_devie"   , 0);
    newRow.setInt("v_limit"   , 0);
    newRow.setInt("poids"     , 0);
    newRow.setInt("meca0"     , 0);
    newRow.setInt("meca1"     , 0);
    newRow.setInt("t_cib0"    , 0);
    newRow.setInt("t_cib1"    , 0);
    newRow.setInt("butoir0"   , 0);
    newRow.setInt("butoir1"   , 0);
    newRow.setInt("manoeuv"   , 0);
    newRow.setString("ID_zone", "_");
    
    int compte_paves = 0;
    for (int c = 0; c < C_MAX; c++) {
        for (int l = 0; l < 2*L_MAX; l++) {
            if (c == 0 && l == 0) {
                newRow = TCO.addRow();
                TCO.setInt(compte_paves,    "colonne" , zoom_x);
                TCO.setInt(compte_paves,    "ligne"   , zoom_y);
                TCO.setInt(compte_paves,    "type"    , -1);
                TCO.setInt(compte_paves,    "elong"   , palette.zoom_p);
                if (zoom_pupitre < 50) {
                    TCO.setInt(compte_paves,    "orient"  , 50);
                } else {
                    TCO.setInt(compte_paves,    "orient"  , zoom_pupitre);
                }
                TCO.setInt(compte_paves,    "retr00"  , x_palette);
                TCO.setInt(compte_paves,    "retr01"  , y_palette);
                TCO.setInt(compte_paves,    "retr02"  , x_pupitre);
                TCO.setInt(compte_paves,    "retr03"  , y_pupitre);
            } else {           
                pave = tco.paves[c][l];
                if (pave != null) {
                    newRow = TCO.addRow();                
                    compte_paves++;
                    TCO.setInt(compte_paves, "colonne"    , c);
                    TCO.setInt(compte_paves, "ligne"      , l);
                    TCO.setInt(compte_paves, "type"       , tco.paves[c][l].type);
                    TCO.setInt(compte_paves, "elong"      , tco.paves[c][l].elongation);
                    TCO.setInt(compte_paves, "orient"     , tco.paves[c][l].orientation);
                    TCO.setInt(compte_paves, "retr00"     , int(tco.paves[c][l].connecteur[0][0].z));
                    TCO.setInt(compte_paves, "retr01"     , int(tco.paves[c][l].connecteur[0][1].z));
                    TCO.setInt(compte_paves, "retr02"     , int(tco.paves[c][l].connecteur[0][2].z));
                    TCO.setInt(compte_paves, "retr03"     , int(tco.paves[c][l].connecteur[0][3].z));
                    TCO.setInt(compte_paves, "retr10"     , int(tco.paves[c][l].connecteur[1][0].z));
                    TCO.setInt(compte_paves, "retr11"     , int(tco.paves[c][l].connecteur[1][1].z));
                    TCO.setInt(compte_paves, "retr12"     , int(tco.paves[c][l].connecteur[1][2].z));
                    TCO.setInt(compte_paves, "retr13"     , int(tco.paves[c][l].connecteur[1][3].z));
                    TCO.setInt(compte_paves, "cible0"     , int(tco.paves[c][l].cible[0]));
                    TCO.setInt(compte_paves, "cible1"     , int(tco.paves[c][l].cible[1]));
                    TCO.setInt(compte_paves, "cib_v0"     , int(tco.paves[c][l].cible_visible[0]));
                    TCO.setInt(compte_paves, "cib_v1"     , int(tco.paves[c][l].cible_visible[1]));
                    TCO.setInt(compte_paves, "lg_voie"    , tco.paves[c][l].longueur_voie);
                    TCO.setInt(compte_paves, "ht_voie"    , tco.paves[c][l].hauteur_voie);
                    TCO.setInt(compte_paves, "ordre"      , tco.paves[c][l].ordre);
                    TCO.setInt(compte_paves, "v_devie"    , tco.paves[c][l].vitesse_deviee);
                    TCO.setInt(compte_paves, "v_limit"    , tco.paves[c][l].vitesse_limite);
                    TCO.setInt(compte_paves, "poids"      , int(tco.paves[c][l].poids));
                    TCO.setInt(compte_paves, "meca0"      , int(tco.paves[c][l].mecanique[0]));
                    TCO.setInt(compte_paves, "meca1"      , int(tco.paves[c][l].mecanique[1]));
                    TCO.setInt(compte_paves, "t_cib0"     , tco.paves[c][l].type_cible[0]);
                    TCO.setInt(compte_paves, "t_cib1"     , tco.paves[c][l].type_cible[1]);
                    TCO.setInt(compte_paves, "butoir0"    , int(tco.paves[c][l].butoir[0]));
                    TCO.setInt(compte_paves, "butoir1"    , int(tco.paves[c][l].butoir[1]));
                    TCO.setInt(compte_paves, "manoeuv"    , tco.paves[c][l].manoeuvre);
                    TCO.setString(compte_paves, "ID_zone" , tco.paves[c][l].ID_zone);
                }
            }
        }
    }
    TCO.setInt(0,"ordre",compte_paves);
    
    String str_ye = str(year());
    String str_mo = str(100+month()).substring(1,3);
    String str_da = str(100+day()).substring(1,3);
    String str_ho = str(100+hour()).substring(1,3);
    String str_mi = str(100+minute()).substring(1,3);
    String str_se = str(100+second()).substring(1,3);                
    
    date = str_ye+"_"+str_mo+"_"+str_da;
    date = date+"__"+str_ho+"_"+str_mi+"_"+str_se;
    
    saveTable(TCO,"data/TCO____"+date+".tsv");
    if (sauve) {
        showMessageDialog(null, "Sauvegarde effectuee le "+str_da+"/"+str_mo+"/"+str_ye+" a "+str_ho+":"+str_mi+":"+str_se);
    }
}
