//************************************ class Zone *************************************************
class Zone {
    String  ID_zone;                                                                                                                              //  identifiant de la zone
    float   longueur_zone    = 0F;                                                                                                                //  longueur de la zone
    int     nb_connecteurs   = 0;                                                                                                                 //  nombre de connecteurs de la zone
    int     cote             = 0;                                                                                                                 //  cote du signal pans le pave origine
    boolean ID_valide        = false;                                                                                                             //  on a trouve une ID valide
    
    PVector connecteur[];                                                                                                                         //  connecteurs de la zone
    Pave pave_origine = null;                                                                                                                     //  pavé origine de la zone

    ArrayList<Pave> zone     = new ArrayList<Pave>();                                                                                             //  la zone est vue comme une liste de pavés    
    
    Zone() {
        connecteur = new PVector[nb_connecteurs];
    }  //  constructeur
    
    //---------------------------------------------------------- ID_zone() ---------------------------------
    void ID_zone() {
        String  ID_courante  = null;
        int     reponse      = -1;                                                                                                                //  remise a zero de reponse (qui doit être different de 0, 1, 2, 3)    
        //---------------------------------------------------------------------------------------------------------------------- Premiere etape : demande de l'ID
        ID_courante = showInputDialog("Entrez l'identifiant de la zone");
        if (ID_courante != null) {
            if (ID_courante.equals("") || ID_courante.equals(" ")) {
                showMessageDialog(null, "Il n'y a pas d'identifiant dans votre entrée",
                                        "Attention", ERROR_MESSAGE);
            } else {
                for (int c = 0; c < C_MAX; c++) {
                    for (int l = 0; l < 2*L_MAX; l++) {
                        paveCL = tco.paves[c][l];
                        if (paveCL != null) {
                            if (ID_courante.equals(paveCL.ID_zone)) {
                                if (reponse == -1) {
                                    showMessageDialog(null, "Votre identifiant de zone est déjà utilisé"
                                                  +char(10)+"Vérifiez bien que votre zone sera en un seul morceau !"
                                                           ,"Attention", ERROR_MESSAGE);
                                    Object[] options = { "Créer", "Ajouter", "Sortir" };
                                    reponse = showOptionDialog(null, " Que voulez vous faire de votre sélection ?"+        
                                                   char(10)+char(10)+" Créer   : Effacer l'ancienne zone ayant "+ID_courante+" comme identifiant"+
                                                            char(10)+"           et ne garder pour la zone que les pavés sélectionnés"+
                                                            char(10)+" Ajouter : Ajouter votre sélection à la zone existante"+
                                                            char(10)+" Sortir  : Ne pas tenir compte de la nouvelle sélection",
                                                                     "Choisissez",
                                                                     YES_NO_CANCEL_OPTION, QUESTION_MESSAGE,
                                                                     null, options, options[2]);
                                }
                                switch (reponse) {
                                    case 0 :                                                                                                      //------ creer
                                        paveCL.ID_zone  = "_";                                                                                    //  remise a zero de l'ID_zone
                                        for (int i = 0; i < 2; i++) {
                                            for (int j = 0; j < 4; j++) {
                                                paveCL.connecteur[i][j].z = 0;                                                                    //  nettoyage des retraits (z <= 0 => retrait non visible)
                                            }
                                        }
                                        ID_valide = true;
                                        zone.clear();
                                        break;
                                    case 1 :                                                                                                      //----- ajouter
                                        zone.add(paveCL);                                                                                         //  ajoute un pavé dans la liste de pavés creee
                                        paveCL.ID_zone = ID_courante;                                                                             //  met a jour l'ID_zone dans le pavé
                                        ID_valide = true;
                                        break;
                                    case 2 :                                                                                                      //----- sortir
                                        showMessageDialog(null, "Rien n'a été fait : les pavés et les identifiants de zone sont conservés");
                                        ID_valide = false;
                                        c = C_MAX;                                                                                                //  on peut sortir des deux boucles
                                        l = 2*L_MAX;
                                        break;
                                }                                
                            } else {
                                ID_valide = true;
                            }
                        }
                    }
                }            
            }
        }   
        //---------------------------------------------------------------------------------------------------------------------  Deuxieme etape : recuperation des pavés s'ils ne sont pas deja pris
        if (ID_valide) {
            for (int c = 0; c < C_MAX; c++) {
                for (int l = 0; l < 2*L_MAX; l++) {
                    paveCL = tco.paves[c][l];
                    if (paveCL != null && paveCL.selectionne) {
                        if (paveCL.ID_zone.equals("_") || paveCL.ID_zone.equals(ID_courante)) {                                                   //  le pavé n'a pas d'identifiant ou son identifiant est le meme que celui qu'on veut mettre
                            zone.add(paveCL);                                                                                                     //  ajoute un pavé dans la liste de pavés creee
                            paveCL.ID_zone = ID_courante;                                                                                         //  met l'identifiant de zone dans le pavé
                            ID_valide = true;
                        } else {                                                                                                                  //  il y a deja des autres identifiants pour les pavés sélectionnes
                            showMessageDialog(null, "Il y a un mélange dans les identifiants de zone"
                                          +char(10)+"Commencez par rétrécir la zone "+paveCL.ID_zone+" avant de crér la zone "+ID_courante
                                          +char(10)+"Votre sélection sera annulée"
                                                   ,"Attention", ERROR_MESSAGE);
                            ID_valide = false;
                            c = C_MAX;
                            break;
                        }
                    }
                }
            }       
        }   
        //---------------------------------------------------------------------------------------------------------------------  Troisieme etape : rendre invisibles les retraits internes a la zone   
        if (ID_valide) {
            //affiche_origine = false;
            for (Pave pave1 : zone_traitee.zone) {
                pave1.cible[0]         = true;                                                                                                    //  on met des cibles à chaque extrémité de pavé : coté 0
                pave1.cible[1]         = true;                                                                                                    //  on met des cibles à chaque extrémité de pavé : coté 1
                pave1.cible_visible[0] = true;                                                                                                    //  on met des cibles visibles à chaque extrémité de pavé : coté 0
                pave1.cible_visible[1] = true;                                                                                                    //  on met des cibles visibles à chaque extrémité de pavé : coté 1
                for (int i = 0; i < 2; i++) {
                    if (pave1.appareil_de_voie || pave1.type == 2) {
                        pave1.cible[i]         = false;                                                                                           //  il n'y a pas de cible sur un appareil de voie ou un butoir
                        pave1.cible_visible[i] = false;                                                                                           //  il n'y a pas de cible visible sur un appareil de voie ou un butoir
                    }
                    for (int j = 0; j < 4; j++) {
                        pave1.connecteur[i][j].z = 1;                                                                                             //  au depart, tous les retraits sont valides et pleins (z = 1 => retrait plein)
                    }
                }
            }
            nb_connecteurs = 0;
            for (Pave pave1 : zone_traitee.zone) {                                                                                                //  comparatif deux a deux de toutes les positions des connecteurs :
                for (int i1 = 0; i1 < 2; i1++) {                                                                                                  //  origine et extremite
                    for (int j1 = 0; j1 < 4; j1++) {                                                                                              //  jusqu'a 4 formes par pavé
                        if (pave1.connecteur[i1][j1].x != 0 && pave1.connecteur[i1][j1].y != 0) {                                                 //  on ne compare que les connecteurs existants
                            nb_connecteurs++;
                            for (Pave pave2 : zone_traitee.zone) {                                                                                //  deuxieme serie de connecteurs
                                for (int i2 = 0; i2 < 2; i2++) {                                                                                  //  origine et extremite
                                    for (int j2 = 0; j2 < 4; j2++) {                                                                              //  jusqu'a 4 formes par pavé
                                        if (pave2.connecteur[i2][j2].x != 0 && pave2.connecteur[i2][j2].y != 0) {                                 //  on ne compare que les connecteurs existants
                                            if (PVector.dist(pave1.connecteur[i1][j1], pave2.connecteur[i2][j2]) < 1.1 && pave1 != pave2) {       //  les connecteurs sont au meme endroit, sur des pavés distincts
                                                pave1.connecteur[i1][j1].z = 0;                                                                   //  le retrait commun est efface sur le pave1 (0 = pas de retrait visible)
                                                pave2.connecteur[i2][j2].z = 0;                                                                   //  le retrait commun est efface sur le pave2 (0 = pas de retrait visible)
                                                if (!pave1.appareil_de_voie && !pave2.appareil_de_voie) {                                         //  si des deux côtés du connecteur, on n'a pas d'appareil de voie, on efface les cibles
                                                    pave1.cible[i1]         = false;                                                              //  ... entre autres, on efface toutes les cibles des butoir
                                                    pave2.cible[i2]         = false;
                                                    pave1.cible_visible[i1] = false;
                                                    pave2.cible_visible[i2] = false;
                                                }
                                                if (pave1.type == 2) {                                                                            //  si le butoir est côté pave1, on ajoute une cible sur le pave2, côté butoir                                                  
                                                    pave2.cible[i2]         = true;
                                                    pave2.cible_visible[i2] = true;
                                                }
                                                if (pave2.type == 2) {                                                                            //  si le butoir est côté pave2, on ajoute une cible sur le pave1, côté butoir                                                                            
                                                    pave1.cible[i1]         = true;
                                                    pave1.cible_visible[i1] = true;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }                                                                                                                                     //  au sortir de ces boucles, toutes les cibles nécessaires sont là, toutes visibles aussi
            //----------------------------------------- Recherche des deux connecteurs de la zone ------------------
            int compte = -1;
            connecteur = new PVector[nb_connecteurs];
            for (Pave pave1 : zone_traitee.zone) {                                                                                                //  on teste tous les connecteurs des pavés de la zone :
                for (int i1 = 0; i1 < 2; i1++) {                                                                                                  //  origine et extremite
                    for (int j1 = 0; j1 < 4; j1++) {                                                                                              //  jusqu'a 4 formes par pavé
                        if (pave1.connecteur[i1][j1].z == 1 && pave1.connecteur[i1][j1].x != 0 && pave1.connecteur[i1][j1].y != 0) {              //  on ne garde que les connecteurs qui ont un retrait(ce sont les seuls a l'extremite)
                            compte++;
                            connecteur[compte] = pave1.connecteur[i1][j1];                                                                        //  ---- on a trouve les deux connecteurs de la zone
                            if (compte == 0) {
                                pave_origine = pave1;
                                                                                            println("pave_origine trouvé = ", pave_origine.c, pave_origine.l, "zone_traitée = ", zone_traitee);
                            }
                        }
                    }
                }
            }
            affiche_origine = true;
            passe_one_shot  = false;
        }
    }
    //------------------------------------- ID_zone_suite() ----------------------------------------------------------------------------------------------
    void ID_zone_suite() {
        if (affiche_origine && passe_one_shot) {
            int     reponse      = -1;                                                                                                            //  remise a zero de reponse (qui doit être different de 0, 1, 2, 3)
            int     memo_reponse = -1;
            affiche_origine = false;
            for (Pave pave1 : zone_traitee.zone) {
                                                                                    println("pave de la zone_traitee.zone = ", pave1.c, pave1.l);
                if (reponse == -1) {
                    Object[] options = { "_|______|_", "_|________", "________|_", "__________" };
                    reponse = showOptionDialog(null, "    Où voulez vous positionner les signaux ?"+        
                                   char(10)+char(10)+" _|______|_  : Voie banalisée"+
                                            char(10)+" _|________ : Signal uniquement à l'origine"+
                                            char(10)+"                          (du côté point rouge)"+
                                            char(10)+" ________|_ : Signal uniquement à l'extremité"+
                                            char(10)+"                          (du côté opposé au point rouge)"+
                                            char(10)+" _________ : Aucun signal"+
                                   char(10)+char(10)+"        (options modifiables à tout moment)"+char(10),
                                                     "Choisissez",
                                                     DEFAULT_OPTION, QUESTION_MESSAGE,
                                                     null, options, options[0]);
                }
                memo_reponse = reponse;                                                                                                              //  comme toutes les cibles sont visibles, il n'y a plus qu'à effacer les cibles qu'on ne veut pas voir
                switch (reponse) {
                    case 0 :
                        break;
                    case 1 :
                        pave1.cible_visible[1] = false;
                        break;
                    case 2 :
                        pave1.cible_visible[0] = false;
                        break;
                    case 3 :
                        pave1.cible_visible[0] = false;
                        pave1.cible_visible[1] = false;
                }
                if (!pave1.appareil_de_voie) {                                                                                                    //  on ne tient pas compte de la longueur des appareils de voie
                    longueur_zone  = longueur_zone+pave1.longueur_pave;                                                                           //  calcul de la longueur totale des pavés constituant la zone
                }
            }
            //----------------------------------------- Ajout des cibles de la zone créée à la liste des cibles ------------------
            for (Pave pave1 : zone_traitee.zone) {                                                                                                    //  on teste tous les pavés de la zone :
                tous_signaux.remove(pave1);                                                                                                           //  efface tous les pavés de la zone qui sont deja dans cibles
            }
            for (Pave pave1 : zone_traitee.zone) {                                                                                                    //  on teste tous les pavés de la zone :
                if (pave1.cible[0] || pave1.cible[1]) {                                                                                                   //  s'il y a au moins une cible
                    tous_signaux.add(pave1);                                                                                                          //  ajoute le pavé dans la liste des pavé avec signal
                }
            }
            //-------------------------------------------------- choix des feux (mécaniques ou lumineux) ---------------------------------------------------------
            reponse = -1;
            for (Pave pave1 : zone_traitee.zone) {
                switch (memo_reponse) {
                    case 0 :                                                                                                                      //  voie banalisée
                        if (reponse == -1) {
                            Object[] options = { "_L______L_", "_M______L_", "_L______M_", "_M______M_" };
                            reponse = showOptionDialog(null, "Sur cette zone banalisée, voulez-vous des signaux mécaniques (M) ou lumineux (L) ?"+        
                                           char(10)+char(10)+" _L______L_ : Lumineux des deux côtés"+
                                                    char(10)+" _M______L_ : Mécaniques à l'origine et lumineux à l'extrémité"+
                                                    char(10)+" _L______M_ : Lumineux à l'origine et mécaniques à l'extrémité"+
                                                    char(10)+" _M______M_ : Mécaniques des deux côtés"+
                                           char(10)+char(10)+"        (options modifiables à tout moment)"+char(10),
                                                             "Choisissez",
                                                             DEFAULT_OPTION, QUESTION_MESSAGE,
                                                             null, options, options[0]);
                        }
                        switch (reponse) {
                            case 0 :                                //MM
                                pave1.mecanique[0] = false;
                                pave1.mecanique[1] = false;
                                break;
                            case 1 :                                //ML
                                pave1.mecanique[0] = true;
                                pave1.mecanique[1] = false;
                                break;
                            case 2 :                                //LM
                                pave1.mecanique[0] = false;
                                pave1.mecanique[1] = true;
                                break;
                            case 3 :                                //LL
                                pave1.mecanique[0] = true;
                                pave1.mecanique[1] = true;
                        }
                        break;
                    case 1 :                                                                                                                      //  feu uniquement à l'origine
                        if (reponse == -1) {
                            Object[] options = { "_L________", "_M________" };
                            reponse = showOptionDialog(null, "Sur cette zone avec un feu à l'origine, voulez-vous un signal lumineux (L) ou mécaniques (M) ?"+        
                                           char(10)+char(10)+" _L________ : Lumineux"+
                                                    char(10)+" _M________ : Mécanique"+
                                           char(10)+char(10)+"        (options modifiables à tout moment)"+char(10),
                                                             "Choisissez",
                                                             DEFAULT_OPTION, QUESTION_MESSAGE,
                                                             null, options, options[0]);
                        }
                        switch (reponse) {
                            case 0 :
                                pave1.mecanique[0] = true;
                                pave1.mecanique[1] = false;
                                break;
                            case 1 :
                                pave1.mecanique[0] = false;
                                pave1.mecanique[1] = false;
                                break;
                        }
                        break;
                    case 2 :                                                                                                                      //  feu niquement à l'extrémité
                        if (reponse == -1) {
                            Object[] options = { "________L_", "________M_" };
                            reponse = showOptionDialog(null, "Sur cette zone avec un feu à l'extrémité, voulez-vous un signal lumineux (L) ou mécaniques (M) ?"+        
                                           char(10)+char(10)+" ________L_ : Lumineux"+
                                                    char(10)+" ________M_ : Mécanique"+
                                           char(10)+char(10)+"        (options modifiables à tout moment)"+char(10),
                                                             "Choisissez",
                                                             DEFAULT_OPTION, QUESTION_MESSAGE,
                                                             null, options, options[0]);
                        }
                        switch (reponse) {
                            case 0 :
                                pave1.mecanique[0] = false;
                                pave1.mecanique[1] = true;
                                break;
                            case 1 :
                                pave1.mecanique[0] = false;
                                pave1.mecanique[1] = false;
                                break;
                        }
                        break;
                    case 3 :                                                                                                                      //  aucun feu
                        break;                        
                }
            }
            //-------------------------------------------------- choix des limites de vitesse de zone ---------------------------------------------------------
            reponse = -1;
            for (Pave pave1 : zone_traitee.zone) {
                if (reponse == -1) {
                    Object[] options = { "Pas de limite", "30 km/h", "60 km/h", "160 km/h" };
                    reponse = showOptionDialog(null, "Choisissez la limite de vitesse qui sera effective sur toute la zone",        
                                                     "                                                  Choisissez",
                                                     DEFAULT_OPTION, QUESTION_MESSAGE,
                                                     null, options, options[0]);
                }
                switch (reponse) {
                    case 0 :
                        pave1.vitesse_limite = 0;
                        break;
                    case 1 :
                        pave1.vitesse_limite = 30;
                        break;
                    case 2 :
                        pave1.vitesse_limite = 60;
                        break;
                    case 3 :
                        pave1.vitesse_limite = 160;
                }
            }            
            //-------------------------------------------------- choix des zones de manoeuvre ---------------------------------------------------------
            reponse = -1;
            for (Pave pave1 : zone_traitee.zone) {
                if (reponse == -1) {
                    Object[] options = { "VP (Voie Principale)", "VS (Voie de Service)", "VP donnant sur VS ou VS donnant sur VP" };
                    reponse = showOptionDialog(null, "Choisissez le type de voie",        
                                                     "Choisissez",
                                                     DEFAULT_OPTION, QUESTION_MESSAGE,
                                                     null, options, options[0]);
                }
                switch (reponse) {
                    case 0 :
                        pave1.manoeuvre = 0;
                        break;
                    case 1 :
                        pave1.manoeuvre = 1;
                        break;
                    case 2 :
                        pave1.manoeuvre = 2;
                        break;
                }
            }
            unselect_all();
            voie_pont_tournant_posee = false;
            mode_selection           = false;
            one_shot = true;
            cursor(ARROW);
        }
    }
}
//------------------------------------------------- affiche_origine1() -------------------------------------------------------
void affiche_origine1() {
    if (affiche_origine) {
                                                                                    println("zone traitée dans affiche origine 1 = ", zone_traitee);
                                                                                    //println(zone_traitee.pave_origine.c, zone_traitee.pave_origine.l);
        if (zone_traitee.pave_origine != null) {
            fill(ROUGE);
            ellipse(zone_traitee.pave_origine.connecteur[zone_traitee.cote][0].x, zone_traitee.pave_origine.connecteur[zone_traitee.cote][0].y, MAILLE*zoom_x/2F, MAILLE*zoom_x/2F);
        }
        one_shot = true;
    }
}
//------------------------------------------------- affiche_origine2() -------------------------------------------------------
void affiche_origine2() {
    if (affiche_origine) {
                                                                                    println("zone traitée dans affiche origine 2 = ", zone_traitee);
        if (zone_traitee.pave_origine != null) {
            fill(ROUGE);
            ellipse(zone_traitee.pave_origine.connecteur[zone_traitee.cote][0].x, zone_traitee.pave_origine.connecteur[zone_traitee.cote][0].y, MAILLE*zoom_x/2F, MAILLE*zoom_x/2F);
        }
        passe_one_shot = true;
    }
}
